#!/usr/bin/env python
# -*- coding: UTF-8 -*-



##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from MainTemplate import MainTemplate
from nav.web import shouldShow

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1222677379.6318979
__CHEETAH_genTimestamp__ = 'Mon Sep 29 08:36:19 2008'
__CHEETAH_src__ = 'FrontpageTemplate.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Jan 19 14:16:23 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class FrontpageTemplate(MainTemplate):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        MainTemplate.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def additionalCSS(self, **KWS):



        ## CHEETAH: generated from #block additionalCSS at line 36, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<link rel="stylesheet" type="text/css" href="/style/FrontpageTemplate.css" />
''')
        _v = VFFSL(SL,"default_table_CSS",True) # '$default_table_CSS' on line 38, col 1
        if _v is not None: write(_filter(_v, rawExpr='$default_table_CSS')) # from line 38, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def content(self, **KWS):



        ## CHEETAH: generated from #block content at line 41, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<table border="0" cellspacing="0" cellpadding="0">
    <tr>
        <td valign="top" width="190">

''')
        _v = VFFSL(SL,"navlinksbox",True) # '$navlinksbox' on line 46, col 1
        if _v is not None: write(_filter(_v, rawExpr='$navlinksbox')) # from line 46, col 1.
        write(''' <br />
''')
        _v = VFFSL(SL,"externallinksbox",True) # '$externallinksbox' on line 47, col 1
        if _v is not None: write(_filter(_v, rawExpr='$externallinksbox')) # from line 47, col 1.
        write(''' <br />
''')
        _v = VFFSL(SL,"contactinformationbox",True) # '$contactinformationbox' on line 48, col 1
        if _v is not None: write(_filter(_v, rawExpr='$contactinformationbox')) # from line 48, col 1.
        write(''' <br />

        </td>
        <td style="width: 10px;"></td>
        <td valign="top">

''')
        _v = VFFSL(SL,"welcome",True) # '$welcome' on line 54, col 1
        if _v is not None: write(_filter(_v, rawExpr='$welcome')) # from line 54, col 1.
        write('''
''')
        _v = VFFSL(SL,"messages",True) # '$messages' on line 55, col 1
        if _v is not None: write(_filter(_v, rawExpr='$messages')) # from line 55, col 1.
        write('''
''')
        _v = VFFSL(SL,"status",True) # '$status' on line 56, col 1
        if _v is not None: write(_filter(_v, rawExpr='$status')) # from line 56, col 1.
        write('''

        </td>
    </tr>
</table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def navlinksbox(self, **KWS):



        ## CHEETAH: generated from #def navlinksbox at line 63, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''  ''')
        _v = VFFSL(SL,"sideboxstart",False)('NAV links') # "$sideboxstart('NAV links')" on line 64, col 3
        if _v is not None: write(_filter(_v, rawExpr="$sideboxstart('NAV links')")) # from line 64, col 3.
        write('''
  ''')
        _v = VFFSL(SL,"navlinks",True) # '$navlinks' on line 65, col 3
        if _v is not None: write(_filter(_v, rawExpr='$navlinks')) # from line 65, col 3.
        write('''
  ''')
        _v = VFFSL(SL,"sideboxend",False)() # '$sideboxend()' on line 66, col 3
        if _v is not None: write(_filter(_v, rawExpr='$sideboxend()')) # from line 66, col 3.
        write('''     
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def navlinks(self, **KWS):



        ## CHEETAH: generated from #def navlinks at line 69, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def externallinksbox(self, **KWS):



        ## CHEETAH: generated from #def externallinksbox at line 72, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''  ''')
        _v = VFFSL(SL,"sideboxstart",False)('External links') # "$sideboxstart('External links')" on line 73, col 3
        if _v is not None: write(_filter(_v, rawExpr="$sideboxstart('External links')")) # from line 73, col 3.
        write('''
  ''')
        _v = VFFSL(SL,"externallinks",True) # '$externallinks' on line 74, col 3
        if _v is not None: write(_filter(_v, rawExpr='$externallinks')) # from line 74, col 3.
        write('''
  ''')
        _v = VFFSL(SL,"sideboxend",False)() # '$sideboxend()' on line 75, col 3
        if _v is not None: write(_filter(_v, rawExpr='$sideboxend()')) # from line 75, col 3.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def externallinks(self, **KWS):



        ## CHEETAH: generated from #def externallinks at line 78, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def contactinformationbox(self, **KWS):



        ## CHEETAH: generated from #def contactinformationbox at line 81, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''  ''')
        _v = VFFSL(SL,"sideboxstart",False)('Contact information') # "$sideboxstart('Contact information')" on line 82, col 3
        if _v is not None: write(_filter(_v, rawExpr="$sideboxstart('Contact information')")) # from line 82, col 3.
        write('''
  ''')
        _v = VFFSL(SL,"contactinformation",True) # '$contactinformation' on line 83, col 3
        if _v is not None: write(_filter(_v, rawExpr='$contactinformation')) # from line 83, col 3.
        write('''
  ''')
        _v = VFFSL(SL,"sideboxend",False)() # '$sideboxend()' on line 84, col 3
        if _v is not None: write(_filter(_v, rawExpr='$sideboxend()')) # from line 84, col 3.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def contactinformation(self, **KWS):



        ## CHEETAH: generated from #def contactinformation at line 87, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def welcome(self, **KWS):



        ## CHEETAH: generated from #def welcome at line 90, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def sideboxstart(self, title, **KWS):



        ## CHEETAH: generated from #def sideboxstart($title) at line 93, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''  <table border="0" cellspacing="0" cellpadding="3" width="100%" class="sidebox">
    <tr>
      <td class="sideboxtitle">
        ''')
        _v = VFFSL(SL,"title",True) # '$title' on line 97, col 9
        if _v is not None: write(_filter(_v, rawExpr='$title')) # from line 97, col 9.
        write('''
      </td>
    </tr>
    <tr>
      <td class="sideboxlinks">
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def sideboxend(self, **KWS):



        ## CHEETAH: generated from #def sideboxend at line 104, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''      </td>
    </tr>
  </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def messages(self, **KWS):



        ## CHEETAH: generated from #def messages at line 111, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        msgs = VFFSL(SL,"getVar",False)('msgs', False)
        if VFFSL(SL,"msgs",True): # generated from line 113, col 1
            msgcount = len(VFFSL(SL,"msgs",True))
            rowcount = VFFSL(SL,"msgcount",True) + 1
            write('''<table class="horiztable">
    <caption>
        <span class="cornerkludge"></span>
        <a href="/messages/">Messages</a><br />
''')
            if VFFSL(SL,"msgcount",True) == 1: # generated from line 120, col 9
                write('''        <span class="subtitle">''')
                _v = VFFSL(SL,"msgcount",True) # '$msgcount' on line 121, col 32
                if _v is not None: write(_filter(_v, rawExpr='$msgcount')) # from line 121, col 32.
                write(''' active message</span>
''')
            else: # generated from line 122, col 9
                write('''        <span class="subtitle">''')
                _v = VFFSL(SL,"msgcount",True) # '$msgcount' on line 123, col 32
                if _v is not None: write(_filter(_v, rawExpr='$msgcount')) # from line 123, col 32.
                write(''' active messages</span>
''')
            write('''    </caption>

    <tr class="header">
        <td class="leftkludge" rowspan="''')
            _v = VFFSL(SL,"rowcount",True) # '$rowcount' on line 128, col 41
            if _v is not None: write(_filter(_v, rawExpr='$rowcount')) # from line 128, col 41.
            write('''"></td>
        <th>Published</th>
        <th>Title</th>
        <th style="white-space: normal;">Description</th>
        <th>Tasks</th>
        <td class="rightkludge" rowspan="''')
            _v = VFFSL(SL,"rowcount",True) # '$rowcount' on line 133, col 42
            if _v is not None: write(_filter(_v, rawExpr='$rowcount')) # from line 133, col 42.
            write('''"></td>
    </tr>

''')
            for msg in VFFSL(SL,"msgs",True): # generated from line 136, col 5
                if len(VFFSL(SL,"msg.description",True)) > 80: # generated from line 137, col 9
                    desc = VFN(VFFSL(SL,"msg",True),"description",True)[:80] + '...'
                else: # generated from line 139, col 9
                    desc = VFFSL(SL,"msg.description",True)
                if VFFSL(SL,"msg.tasks",True): # generated from line 142, col 9
                    tasks = len(VFFSL(SL,"msg.tasks",True))
                else: # generated from line 144, col 9
                    tasks = 0
                write('''    <tr class="''')
                _v = VFFSL(SL,"rowcycler",True) # '$rowcycler' on line 147, col 16
                if _v is not None: write(_filter(_v, rawExpr='$rowcycler')) # from line 147, col 16.
                write('''">
        <td>''')
                _v = VFN(VFFSL(SL,"msg.publish_start",True),"strftime",False)('%Y-%m-%d %H:%M') # "$msg.publish_start.strftime('%Y-%m-%d %H:%M')" on line 148, col 13
                if _v is not None: write(_filter(_v, rawExpr="$msg.publish_start.strftime('%Y-%m-%d %H:%M')")) # from line 148, col 13.
                write('''</td>
        <td><a href="/messages/view?id=''')
                _v = VFFSL(SL,"msg.messageid",True) # '$msg.messageid' on line 149, col 40
                if _v is not None: write(_filter(_v, rawExpr='$msg.messageid')) # from line 149, col 40.
                write('''">''')
                _v = VFN(VFN(VFFSL(SL,"msg.title",True),"replace",False)('<', '&lt;'),"replace",False)('>', '&gt;') # "$msg.title.replace('<', '&lt;').replace('>', '&gt;')" on line 149, col 56
                if _v is not None: write(_filter(_v, rawExpr="$msg.title.replace('<', '&lt;').replace('>', '&gt;')")) # from line 149, col 56.
                write('''</a></td>
        <td>''')
                _v = VFN(VFN(VFFSL(SL,"desc",True),"replace",False)('<', '&lt;'),"replace",False)('>', '&gt;') # "$desc.replace('<', '&lt;').replace('>', '&gt;')" on line 150, col 13
                if _v is not None: write(_filter(_v, rawExpr="$desc.replace('<', '&lt;').replace('>', '&gt;')")) # from line 150, col 13.
                write('''</td>
''')
                if VFFSL(SL,"tasks",True): # generated from line 151, col 9
                    write('''        <td><a href="/messages/view?id=''')
                    _v = VFFSL(SL,"msg.messageid",True) # '$msg.messageid' on line 152, col 40
                    if _v is not None: write(_filter(_v, rawExpr='$msg.messageid')) # from line 152, col 40.
                    write('''">
            <img src="/images/wrench.gif" width="10" height="10" alt="Tasks">
            ''')
                    _v = VFFSL(SL,"tasks",True) # '$tasks' on line 154, col 13
                    if _v is not None: write(_filter(_v, rawExpr='$tasks')) # from line 154, col 13.
                    write('''</a></td>
''')
                else: # generated from line 155, col 9
                    write('''        <td>&nbsp;</td>
''')
                write('''    </tr>
''')
            write('''</table>
<br />
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def status(self, **KWS):



        ## CHEETAH: generated from #def status at line 166, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        rowcount = len(VFFSL(SL,"boxesdown",True)) + 1
        write('''<table class="horiztable">
    <caption>
        <span class="cornerkludge"></span>
        <a href="/status/">Status Now</a><br />
        <span class="subtitle">''')
        _v = VFFSL(SL,"numboxesdown",True) # '$numboxesdown' on line 172, col 32
        if _v is not None: write(_filter(_v, rawExpr='$numboxesdown')) # from line 172, col 32.
        write(''' boxes down,
        ''')
        _v = VFFSL(SL,"numboxesshadow",True) # '$numboxesshadow' on line 173, col 9
        if _v is not None: write(_filter(_v, rawExpr='$numboxesshadow')) # from line 173, col 9.
        write(''' in shadow</span>
    </caption>

    <tr class="header">
        <td class="leftkludge" rowspan="''')
        _v = VFFSL(SL,"rowcount",True) # '$rowcount' on line 177, col 41
        if _v is not None: write(_filter(_v, rawExpr='$rowcount')) # from line 177, col 41.
        write('''"></td>
        <th>Sysname</th>
        <th>IP</th>
        <th>Down since</th>
        <th>Downtime</th>
        <td class="rightkludge" rowspan="''')
        _v = VFFSL(SL,"rowcount",True) # '$rowcount' on line 182, col 42
        if _v is not None: write(_filter(_v, rawExpr='$rowcount')) # from line 182, col 42.
        write('''"></td>
    </tr>

''')
        numberdown = 0
        for box in VFFSL(SL,"boxesdown",True): # generated from line 186, col 1
            if not VFFSL(SL,"box",True)[4]: # generated from line 187, col 1
                if VFFSL(SL,"numberdown",True) < VFFSL(SL,"numberOfBoxesShown",True): # generated from line 188, col 3
                    write('''    <tr class="''')
                    _v = VFFSL(SL,"rowcycler",True) # '$rowcycler' on line 189, col 16
                    if _v is not None: write(_filter(_v, rawExpr='$rowcycler')) # from line 189, col 16.
                    write('''">
''')
                    if shouldShow("/browse/$box[1]", VFFSL(SL,"user",True)): # generated from line 190, col 5
                        write('''      <td><a href="/browse/''')
                        _v = VFFSL(SL,"box",True)[1] # '$box[1]' on line 191, col 28
                        if _v is not None: write(_filter(_v, rawExpr='$box[1]')) # from line 191, col 28.
                        write('''">''')
                        _v = VFFSL(SL,"box",True)[1] # '$box[1]' on line 191, col 37
                        if _v is not None: write(_filter(_v, rawExpr='$box[1]')) # from line 191, col 37.
                        write('''</a></td>
''')
                    else: # generated from line 192, col 5
                        write('''      <td>''')
                        _v = VFFSL(SL,"box",True)[1] # '$box[1]' on line 193, col 11
                        if _v is not None: write(_filter(_v, rawExpr='$box[1]')) # from line 193, col 11.
                        write('''</td>
''')
                    write('''      <td>''')
                    _v = VFFSL(SL,"box",True)[2] # '$box[2]' on line 195, col 11
                    if _v is not None: write(_filter(_v, rawExpr='$box[2]')) # from line 195, col 11.
                    write('''</td>
''')
                    since = VFN(VFFSL(SL,"box",True)[3],"strftime",False)('%Y-%m-%d %H:%M')
                    write('''      <td>''')
                    _v = VFFSL(SL,"since",True) # '$since' on line 197, col 11
                    if _v is not None: write(_filter(_v, rawExpr='$since')) # from line 197, col 11.
                    write('''</td>
      <td style="text-align: right;"><span title="''')
                    _v = VFFSL(SL,"box",True)[0] # '$box[0]' on line 198, col 51
                    if _v is not None: write(_filter(_v, rawExpr='$box[0]')) # from line 198, col 51.
                    write('''">''')
                    _v = VFFSL(SL,"box",True)[5] # '$box[5]' on line 198, col 60
                    if _v is not None: write(_filter(_v, rawExpr='$box[5]')) # from line 198, col 60.
                    write('''</span></td>
    </tr>
''')
                numberdown = VFFSL(SL,"numberdown",True) + 1
        write('''
''')
        if len(VFFSL(SL,"boxesdown",True)) > VFFSL(SL,"numberOfBoxesShown",True): # generated from line 205, col 1
            linktext = "(more)"
        else: # generated from line 207, col 1
            linktext = "(to status page)"
        write('''
    <tr>
        <td colspan="6" style="text-align: center; font-size: smaller;">
            <a href="/status/">''')
        _v = VFFSL(SL,"linktext",True) # '$linktext' on line 213, col 32
        if _v is not None: write(_filter(_v, rawExpr='$linktext')) # from line 213, col 32.
        write('''</a>
        </td>
    </tr>
</table>
<br />
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  $Id: FrontpageTemplate.tmpl 3809 2007-01-19 14:16:23Z jodal $
        # 
        #  Copyright 2003, 2004 Norwegian University of Science and Technology
        # 
        #  This file is part of Network Administration Visualized (NAV)
        # 
        #  NAV is free software; you can redistribute it and/or modify
        #  it under the terms of the GNU General Public License as published by
        #  the Free Software Foundation; either version 2 of the License, or
        #  (at your option) any later version.
        # 
        #  NAV is distributed in the hope that it will be useful,
        #  but WITHOUT ANY WARRANTY; without even the implied warranty of
        #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        #  GNU General Public License for more details.
        # 
        #  You should have received a copy of the GNU General Public License
        #  along with NAV; if not, write to the Free Software
        #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
        # 
        # 
        #  Authors: Magnar Sveen <magnars@stud.ntnu.no>
        #           Stein Magnus Jodal <stein.magnus.jodal@uninett.no>
        # 
        write('''




''')
        self.additionalCSS(trans=trans)
        write('''
''')
        self.content(trans=trans)
        write('''












''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    boxesdown = False

    numberOfBoxesShown = 10

    numberOfMessagesShown = 5

    _mainCheetahMethod_for_FrontpageTemplate= 'writeBody'

## END CLASS DEFINITION

if not hasattr(FrontpageTemplate, '_initCheetahAttributes'):
    templateAPIClass = getattr(FrontpageTemplate, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(FrontpageTemplate)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=FrontpageTemplate()).run()


