#!/usr/bin/env python
# -*- coding: UTF-8 -*-



##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from nav.web.templates.MainTemplate import MainTemplate
from nav.web.templates.selectTreeTemplate import selectTreeTemplate

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1222677359.4457459
__CHEETAH_genTimestamp__ = 'Mon Sep 29 08:35:59 2008'
__CHEETAH_src__ = 'editdbTemplate.tmpl'
__CHEETAH_srcLastModified__ = 'Mon Jan 22 16:02:50 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class editdbTemplate(MainTemplate):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        MainTemplate.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def additionalCSS(self, **KWS):



        ## CHEETAH: generated from #def additionalCSS at line 29, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<link rel="stylesheet" type="text/css" href="/style/editdbTemplate.css" />
''')
        _v = VFFSL(SL,"default_form_CSS",False)() # '$default_form_CSS()' on line 31, col 1
        if _v is not None: write(_filter(_v, rawExpr='$default_form_CSS()')) # from line 31, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def additionalJavaScript(self, **KWS):



        ## CHEETAH: generated from #block additionalJavaScript at line 34, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<script type="text/javascript" src="/js/editdbTemplate.js"></script>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def content(self, **KWS):



        ## CHEETAH: generated from #def content at line 38, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        if VFFSL(SL,"entryList",True): # generated from line 39, col 1
            _v = VFFSL(SL,"showSelectList",False)(VFFSL(SL,"entryList",True)) # '$showSelectList($entryList)' on line 40, col 1
            if _v is not None: write(_filter(_v, rawExpr='$showSelectList($entryList)')) # from line 40, col 1.
            write('''
''')
        elif VFFSL(SL,"editList",True): # generated from line 41, col 1
            _v = VFFSL(SL,"showList",False)(VFFSL(SL,"editList",True)) # '$showList($editList)' on line 42, col 1
            if _v is not None: write(_filter(_v, rawExpr='$showList($editList)')) # from line 42, col 1.
            write('''
''')
        elif VFFSL(SL,"editForm",True): # generated from line 43, col 1
            _v = VFFSL(SL,"showForm",False)(VFFSL(SL,"editForm",True)) # '$showForm($editForm)' on line 44, col 1
            if _v is not None: write(_filter(_v, rawExpr='$showForm($editForm)')) # from line 44, col 1.
            write('''
''')
        else: # generated from line 45, col 1
            _v = VFFSL(SL,"showBody",False)(VFFSL(SL,"body",True)) # '$showBody($body)' on line 46, col 1
            if _v is not None: write(_filter(_v, rawExpr='$showBody($body)')) # from line 46, col 1.
            write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def showSelectList(self, selectList, **KWS):



        ## CHEETAH: generated from #def $showSelectList($selectList) at line 77, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''    <h3>''')
        _v = VFFSL(SL,"selectList.title",True) # '$selectList.title' on line 78, col 9
        if _v is not None: write(_filter(_v, rawExpr='$selectList.title')) # from line 78, col 9.
        write('''</h3>
''')
        if VFFSL(SL,"selectList.body",True): # generated from line 79, col 1
            write('''    <p>''')
            _v = VFFSL(SL,"selectList.body",True) # '$selectList.body' on line 80, col 8
            if _v is not None: write(_filter(_v, rawExpr='$selectList.body')) # from line 80, col 8.
            write('''</p>
''')
        if VFFSL(SL,"selectList.status",True): # generated from line 82, col 1
            write('''    ''')
            _v = VFFSL(SL,"showStatus",False)(VFFSL(SL,"selectList.status",True)) # '$showStatus($selectList.status)' on line 83, col 5
            if _v is not None: write(_filter(_v, rawExpr='$showStatus($selectList.status)')) # from line 83, col 5.
            write('''
''')
        #  Filters
        if VFFSL(SL,"selectList.filters",True): # generated from line 86, col 1
            write('''    ''')
            _v = VFFSL(SL,"renderFilters",False)(VFFSL(SL,"selectList",True)) # '$renderFilters($selectList)' on line 87, col 5
            if _v is not None: write(_filter(_v, rawExpr='$renderFilters($selectList)')) # from line 87, col 5.
            write('''
''')
        write('''    <form method="''')
        _v = VFFSL(SL,"selectList.formMethod",True) # '$selectList.formMethod' on line 89, col 19
        if _v is not None: write(_filter(_v, rawExpr='$selectList.formMethod')) # from line 89, col 19.
        write('''" action="''')
        _v = VFFSL(SL,"selectList.formAction",True) # '$selectList.formAction' on line 89, col 51
        if _v is not None: write(_filter(_v, rawExpr='$selectList.formAction')) # from line 89, col 51.
        write('''">
''')
        #  Top buttons
        if VFFSL(SL,"selectList.buttonsTop",True): # generated from line 91, col 1
            write('''        <p>
''')
            for cname,value in VFFSL(SL,"selectList.buttonsTop",True): # generated from line 93, col 1
                write('''            <input type="submit" name="''')
                _v = VFFSL(SL,"cname",True) # '$cname' on line 94, col 40
                if _v is not None: write(_filter(_v, rawExpr='$cname')) # from line 94, col 40.
                write('''" value="''')
                _v = VFFSL(SL,"value",True) # '$value' on line 94, col 55
                if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 94, col 55.
                write('''" />
''')
            write('''        </p>
''')
        write('''        <table border="0" cellspacing="0" cellpadding="0">
''')
        #  Show headings
        write('''            <tr class="header">
                <td class="startheader"></td>
''')
        for cell in VFFSL(SL,"selectList.headings",True): # generated from line 102, col 1
            write('''                <td valign="top">
''')
            if VFFSL(SL,"cell.url",True): # generated from line 104, col 1
                write('''                    <a href="''')
                _v = VFFSL(SL,"cell.url",True) # '$cell.url' on line 105, col 30
                if _v is not None: write(_filter(_v, rawExpr='$cell.url')) # from line 105, col 30.
                write('''">''')
                _v = VFFSL(SL,"cell.text",True) # '$cell.text' on line 105, col 41
                if _v is not None: write(_filter(_v, rawExpr='$cell.text')) # from line 105, col 41.
                write('''</a>&nbsp;
''')
            else: # generated from line 106, col 1
                write('''                    ''')
                _v = VFFSL(SL,"cell.text",True) # '$cell.text' on line 107, col 21
                if _v is not None: write(_filter(_v, rawExpr='$cell.text')) # from line 107, col 21.
                write('''&nbsp;
''')
            if VFFSL(SL,"cell.tooltip",True): # generated from line 109, col 1
                write('''                    <span>
''')
                for line in VFFSL(SL,"cell.tooltip",True): # generated from line 111, col 1
                    write('''                        ''')
                    _v = VFFSL(SL,"line",True) # '$line' on line 112, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$line')) # from line 112, col 25.
                    write('''<br />
''')
                write('''                    </span>
''')
            write('''                </td>
''')
        write('''                <td class="endheader"></td>
            </tr>
''')
        #  Rows
        oddRow = True
        for fullrow in VFFSL(SL,"selectList.rows",True): # generated from line 122, col 1
            #  $fullrow[0] is sortKey
            id = VFFSL(SL,"fullrow",True)[1][0]
            row = VFFSL(SL,"fullrow",True)[1][1]
            #  Set rowstyle
            if VFFSL(SL,"oddRow",True): # generated from line 127, col 1
                rowstyle = 'oddrow'
                oddRow = False
            else: # generated from line 130, col 1
                rowstyle = 'evenrow'
                oddRow = True
            write('''            <tr class="''')
            _v = VFFSL(SL,"rowstyle",True) # '$rowstyle' on line 134, col 24
            if _v is not None: write(_filter(_v, rawExpr='$rowstyle')) # from line 134, col 24.
            write('''">
''')
            #  Cells in a row
            write('''                <td>&nbsp;</td>
''')
            for cell in VFFSL(SL,"row",True): # generated from line 137, col 1
                write('''                <td>
''')
                if VFFSL(SL,"cell.url",True): # generated from line 139, col 1
                    write('''                    <a href="''')
                    _v = VFFSL(SL,"cell.url",True) # '$cell.url' on line 140, col 30
                    if _v is not None: write(_filter(_v, rawExpr='$cell.url')) # from line 140, col 30.
                    write('''">
''')
                elif VFFSL(SL,"cell.tooltip",True): # generated from line 141, col 1
                    write('''                    <a title="" class="info" href="#''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 142, col 53
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 142, col 53.
                    write('''">
''')
                if VFFSL(SL,"cell.image",True): # generated from line 144, col 1
                    write('''                    <img src="''')
                    _v = VFFSL(SL,"cell.image",True) # '$cell.image' on line 145, col 31
                    if _v is not None: write(_filter(_v, rawExpr='$cell.image')) # from line 145, col 31.
                    write('''">
''')
                if VFFSL(SL,"cell.text",True): # generated from line 147, col 1
                    first = True
                    for line in VFFSL(SL,"cell.text",True): # generated from line 149, col 1
                        if not VFFSL(SL,"first",True): # generated from line 150, col 1
                            write('''                        <br />
''')
                        first = False
                        write('''                    ''')
                        _v = VFFSL(SL,"line",True) # '$line' on line 154, col 21
                        if _v is not None: write(_filter(_v, rawExpr='$line')) # from line 154, col 21.
                        write('''
''')
                if VFFSL(SL,"cell.tooltip",True): # generated from line 157, col 1
                    write('''                    <span>
''')
                    first = True
                    for line in VFFSL(SL,"cell.tooltip",True): # generated from line 160, col 1
                        if not VFFSL(SL,"first",True): # generated from line 161, col 1
                            write('''                        <br />
''')
                        first = False
                        write('''                        ''')
                        _v = VFFSL(SL,"line",True) # '$line' on line 165, col 25
                        if _v is not None: write(_filter(_v, rawExpr='$line')) # from line 165, col 25.
                        write('''
''')
                    write('''                    </span>
''')
                if VFFSL(SL,"cell.buttonType",True) == 'chk': # generated from line 169, col 1
                    write('''                    <input type="checkbox" name="''')
                    _v = VFFSL(SL,"selectList.selectCname",True) # '$selectList.selectCname' on line 170, col 50
                    if _v is not None: write(_filter(_v, rawExpr='$selectList.selectCname')) # from line 170, col 50.
                    write('''" value="''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 170, col 82
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 170, col 82.
                    write('''" />
''')
                elif VFFSL(SL,"cell.buttonType",True) == 'rad': # generated from line 171, col 1
                    write('''                    <input type="radio" name="''')
                    _v = VFFSL(SL,"selectList.selectCname",True) # '$selectList.selectCname' on line 172, col 47
                    if _v is not None: write(_filter(_v, rawExpr='$selectList.selectCname')) # from line 172, col 47.
                    write('''" value="''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 172, col 79
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 172, col 79.
                    write('''" />
''')
                elif VFFSL(SL,"cell.buttonType",True) == 'hid': # generated from line 173, col 1
                    write('''                    <input type="hidden" name="''')
                    _v = VFFSL(SL,"selectList.selectCname",True) # '$selectList.selectCname' on line 174, col 48
                    if _v is not None: write(_filter(_v, rawExpr='$selectList.selectCname')) # from line 174, col 48.
                    write('''" value="''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 174, col 80
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 174, col 80.
                    write('''" />
''')
                if VFFSL(SL,"cell.url",True) or VFFSL(SL,"cell.tooltip",True): # generated from line 176, col 1
                    write('''                    </a>
''')
                write('''                    &nbsp;&nbsp;
                </td>
''')
            write('''                <td>&nbsp;</td>
            </tr>
''')
        write('''        </table>
''')
        #  Bottom buttons
        if VFFSL(SL,"selectList.buttonsBottom",True): # generated from line 187, col 1
            write('''        <p>
''')
            for cname,value in VFFSL(SL,"selectList.buttonsBottom",True): # generated from line 189, col 1
                write('''            <input type="submit" name="''')
                _v = VFFSL(SL,"cname",True) # '$cname' on line 190, col 40
                if _v is not None: write(_filter(_v, rawExpr='$cname')) # from line 190, col 40.
                write('''" value="''')
                _v = VFFSL(SL,"value",True) # '$value' on line 190, col 55
                if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 190, col 55.
                write('''" />
''')
            write('''        </p>
''')
        write('''    </form>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def renderFilters(self, slist, **KWS):



        ## CHEETAH: generated from #def renderFilters($slist) at line 201, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<form method="''')
        _v = VFFSL(SL,"slist.formMethod",True) # '$slist.formMethod' on line 202, col 15
        if _v is not None: write(_filter(_v, rawExpr='$slist.formMethod')) # from line 202, col 15.
        write('''" action="''')
        _v = VFFSL(SL,"slist.filterAction",True) # '$slist.filterAction' on line 202, col 42
        if _v is not None: write(_filter(_v, rawExpr='$slist.filterAction')) # from line 202, col 42.
        write('''">
    <table class="header-active">
''')
        filters = VFFSL(SL,"slist.filters",True)
        for listFilter in VFFSL(SL,"filters",True): # generated from line 205, col 1
            write('''        <tr>
            <td>''')
            _v = VFFSL(SL,"listFilter",True)[0] # '${listFilter[0]}' on line 207, col 17
            if _v is not None: write(_filter(_v, rawExpr='${listFilter[0]}')) # from line 207, col 17.
            write('''</td>
            <td>
                <select name="''')
            _v = VFFSL(SL,"listFilter",True)[5] # '${listFilter[5]}' on line 209, col 31
            if _v is not None: write(_filter(_v, rawExpr='${listFilter[5]}')) # from line 209, col 31.
            write('''">
''')
            # raise repr($listFilter)
            for option in VFFSL(SL,"listFilter",True)[9]: # generated from line 211, col 1
                if VFFSL(SL,"option",True)[0][0] == VFFSL(SL,"listFilter",True)[10]: # generated from line 212, col 1
                    write('''                    <option value="''')
                    _v = VFFSL(SL,"option",True)[0][0] # '$option[0][0]' on line 213, col 36
                    if _v is not None: write(_filter(_v, rawExpr='$option[0][0]')) # from line 213, col 36.
                    write('''" selected>''')
                    _v = VFFSL(SL,"option",True)[1][0] # '$option[1][0]' on line 213, col 60
                    if _v is not None: write(_filter(_v, rawExpr='$option[1][0]')) # from line 213, col 60.
                    write('''</option>
''')
                else: # generated from line 214, col 1
                    write('''                    <option value="''')
                    _v = VFFSL(SL,"option",True)[0][0] # '$option[0][0]' on line 215, col 36
                    if _v is not None: write(_filter(_v, rawExpr='$option[0][0]')) # from line 215, col 36.
                    write('''">''')
                    _v = VFFSL(SL,"option",True)[1][0] # '$option[1][0]' on line 215, col 51
                    if _v is not None: write(_filter(_v, rawExpr='$option[1][0]')) # from line 215, col 51.
                    write('''</option>
''')
            write('''                </select>
            </td>
        </tr>
''')
        write('''        <tr>
            <td colspan="2" align="right"><input type="submit" name="''')
        _v = VFFSL(SL,"slist.filterConfirm",True) # '$slist.filterConfirm' on line 223, col 70
        if _v is not None: write(_filter(_v, rawExpr='$slist.filterConfirm')) # from line 223, col 70.
        write('''" value="''')
        _v = VFFSL(SL,"slist.filterConfirmText",True) # '$slist.filterConfirmText' on line 223, col 99
        if _v is not None: write(_filter(_v, rawExpr='$slist.filterConfirmText')) # from line 223, col 99.
        write('''" /></td>
        </tr>
    </table>
</form>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def showStatus(self, status, **KWS):



        ## CHEETAH: generated from #def $showStatus($status) at line 239, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''    <p class="status">
''')
        for message in VFFSL(SL,"status.messages",True): # generated from line 241, col 1
            write('''        ''')
            _v = VFFSL(SL,"message",True) # '$message' on line 242, col 9
            if _v is not None: write(_filter(_v, rawExpr='$message')) # from line 242, col 9.
            write('''<br />
''')
        write('''    </p>
    <p class="error">
''')
        for error in VFFSL(SL,"status.errors",True): # generated from line 246, col 1
            write('''        ''')
            _v = VFFSL(SL,"error",True) # '$error' on line 247, col 9
            if _v is not None: write(_filter(_v, rawExpr='$error')) # from line 247, col 9.
            write('''<br />
''')
        write('''    </p>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def showBody(self, body, **KWS):



        ## CHEETAH: generated from #def $showBody($body) at line 254, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''    <h2>''')
        _v = VFFSL(SL,"body.title",True) # '$body.title' on line 255, col 9
        if _v is not None: write(_filter(_v, rawExpr='$body.title')) # from line 255, col 9.
        write('''</h2>
''')
        if VFFSL(SL,"body.status",True): # generated from line 256, col 1
            write('''    ''')
            _v = VFFSL(SL,"showStatus",False)(VFFSL(SL,"body.status",True)) # '$showStatus($body.status)' on line 257, col 5
            if _v is not None: write(_filter(_v, rawExpr='$showStatus($body.status)')) # from line 257, col 5.
            write('''
''')
        write('''    <p class="infotext">''')
        _v = VFFSL(SL,"body.infotext",True) # '$body.infotext' on line 259, col 25
        if _v is not None: write(_filter(_v, rawExpr='$body.infotext')) # from line 259, col 25.
        write('''</p>
    <p>
''')
        if not VFFSL(SL,"body.showHelp",True): # generated from line 261, col 1
            write('''        <a href="''')
            _v = VFN(VFFSL(SL,"body",True),"help",True)[0] # '$body.help[0]' on line 262, col 18
            if _v is not None: write(_filter(_v, rawExpr='$body.help[0]')) # from line 262, col 18.
            write('''">''')
            _v = VFN(VFFSL(SL,"body",True),"help",True)[1] # '$body.help[1]' on line 262, col 33
            if _v is not None: write(_filter(_v, rawExpr='$body.help[1]')) # from line 262, col 33.
            write('''</a>

''')
        else: # generated from line 264, col 1
            write('''        <a href="''')
            _v = VFN(VFFSL(SL,"body",True),"nohelp",True)[0] # '$body.nohelp[0]' on line 265, col 18
            if _v is not None: write(_filter(_v, rawExpr='$body.nohelp[0]')) # from line 265, col 18.
            write('''">''')
            _v = VFN(VFFSL(SL,"body",True),"nohelp",True)[1] # '$body.nohelp[1]' on line 265, col 35
            if _v is not None: write(_filter(_v, rawExpr='$body.nohelp[1]')) # from line 265, col 35.
            write('''</a>
''')
        write('''    </p>
''')
        for table in VFFSL(SL,"body.tables",True): # generated from line 268, col 1
            write('''    <h3>''')
            _v = VFFSL(SL,"table.title",True) # '$table.title' on line 269, col 9
            if _v is not None: write(_filter(_v, rawExpr='$table.title')) # from line 269, col 9.
            write('''</h3>
''')
            if VFFSL(SL,"table.infotext",True): # generated from line 270, col 1
                write('''    <p>''')
                _v = VFFSL(SL,"table.infotext",True) # '$table.infotext' on line 271, col 8
                if _v is not None: write(_filter(_v, rawExpr='$table.infotext')) # from line 271, col 8.
                write('''</p>
''')
            if VFFSL(SL,"body.showHelp",True): # generated from line 273, col 1
                write('''    <table style="width: 80%;">
''')
            else: # generated from line 275, col 1
                write('''    <table style="width: 40%;">
''')
            if VFFSL(SL,"table.headings",True): # generated from line 278, col 1
                write('''        <tr>
''')
                for heading in VFFSL(SL,"table.headings",True): # generated from line 280, col 1
                    write('''            <th>''')
                    _v = VFFSL(SL,"heading",True) # '$heading' on line 281, col 17
                    if _v is not None: write(_filter(_v, rawExpr='$heading')) # from line 281, col 17.
                    write('''</th>
''')
                write('''        </tr>
''')
            odd = False
            for row in VFFSL(SL,"table.rows",True): # generated from line 286, col 1
                if odd == True: # generated from line 287, col 1
                    style = "oddrow"
                    odd = False
                else: # generated from line 290, col 1
                    style = "evenrow"
                    odd = True
                if VFFSL(SL,"body.showHelp",True): # generated from line 294, col 1
                    rowstyle = ['width: 10%;','width: 60%;','','','']
                else: # generated from line 296, col 1
                    rowstyle = ['width: 40%;','','width: 15%;','width: 15%;','width: 30%;']
                write('''        <tr class="''')
                _v = VFFSL(SL,"style",True) # '$style' on line 299, col 20
                if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 299, col 20.
                write('''" title="''')
                _v = VFFSL(SL,"row",True)[1] # '$row[1]' on line 299, col 35
                if _v is not None: write(_filter(_v, rawExpr='$row[1]')) # from line 299, col 35.
                write('''">
            <td style="''')
                _v = VFFSL(SL,"rowstyle",True)[0] # '$rowstyle[0]' on line 300, col 24
                if _v is not None: write(_filter(_v, rawExpr='$rowstyle[0]')) # from line 300, col 24.
                write('''">''')
                _v = VFFSL(SL,"row",True)[0] # '$row[0]' on line 300, col 38
                if _v is not None: write(_filter(_v, rawExpr='$row[0]')) # from line 300, col 38.
                write('''</td>
''')
                if VFFSL(SL,"body.showHelp",True): # generated from line 301, col 1
                    write('''            <td style="''')
                    _v = VFFSL(SL,"rowstyle",True)[1] # '$rowstyle[1]' on line 302, col 24
                    if _v is not None: write(_filter(_v, rawExpr='$rowstyle[1]')) # from line 302, col 24.
                    write('''">''')
                    _v = VFFSL(SL,"row",True)[1] # '$row[1]' on line 302, col 38
                    if _v is not None: write(_filter(_v, rawExpr='$row[1]')) # from line 302, col 38.
                    write('''</td>
''')
                if VFFSL(SL,"row",True)[2]: # generated from line 304, col 1
                    #  Add
                    write('''            <td style="''')
                    _v = VFFSL(SL,"rowstyle",True)[2] # '$rowstyle[2]' on line 306, col 24
                    if _v is not None: write(_filter(_v, rawExpr='$rowstyle[2]')) # from line 306, col 24.
                    write('''"><a href="''')
                    _v = VFFSL(SL,"row",True)[2][0] # '$row[2][0]' on line 306, col 47
                    if _v is not None: write(_filter(_v, rawExpr='$row[2][0]')) # from line 306, col 47.
                    write('''">''')
                    _v = VFFSL(SL,"row",True)[2][1] # '$row[2][1]' on line 306, col 59
                    if _v is not None: write(_filter(_v, rawExpr='$row[2][1]')) # from line 306, col 59.
                    write('''</a></td>
''')
                else: # generated from line 307, col 1
                    write('''            <td>&nbsp;</td>
''')
                write('''            <td style="''')
                _v = VFFSL(SL,"rowstyle",True)[3] # '$rowstyle[3]' on line 310, col 24
                if _v is not None: write(_filter(_v, rawExpr='$rowstyle[3]')) # from line 310, col 24.
                write('''"><a href="''')
                _v = VFFSL(SL,"row",True)[3][0] # '$row[3][0]' on line 310, col 47
                if _v is not None: write(_filter(_v, rawExpr='$row[3][0]')) # from line 310, col 47.
                write('''">''')
                _v = VFFSL(SL,"row",True)[3][1] # '$row[3][1]' on line 310, col 59
                if _v is not None: write(_filter(_v, rawExpr='$row[3][1]')) # from line 310, col 59.
                write('''</a></td>
''')
                if VFFSL(SL,"row",True)[4]: # generated from line 311, col 1
                    #  Bulk import
                    write('''            <td style="''')
                    _v = VFFSL(SL,"rowstyle",True)[4] # '$rowstyle[4]' on line 313, col 24
                    if _v is not None: write(_filter(_v, rawExpr='$rowstyle[4]')) # from line 313, col 24.
                    write('''"><a href="''')
                    _v = VFFSL(SL,"row",True)[4][0] # '$row[4][0]' on line 313, col 47
                    if _v is not None: write(_filter(_v, rawExpr='$row[4][0]')) # from line 313, col 47.
                    write('''">''')
                    _v = VFFSL(SL,"row",True)[4][1] # '$row[4][1]' on line 313, col 59
                    if _v is not None: write(_filter(_v, rawExpr='$row[4][1]')) # from line 313, col 59.
                    write('''</a></td>
''')
                else: # generated from line 314, col 1
                    write('''            <td>&nbsp;</td>
''')
                write('''        </tr>
''')
            write('''    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def showList(self, list, **KWS):



        ## CHEETAH: generated from #def showList($list) at line 326, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''    <h3>''')
        _v = VFFSL(SL,"list.title",True) # '$list.title' on line 327, col 9
        if _v is not None: write(_filter(_v, rawExpr='$list.title')) # from line 327, col 9.
        write('''</h3>
''')
        if VFFSL(SL,"list.status",True): # generated from line 328, col 1
            write('''    <p class="status">
''')
            for message in VFFSL(SL,"list.status.messages",True): # generated from line 330, col 1
                write('''        ''')
                _v = VFFSL(SL,"message",True) # '$message' on line 331, col 9
                if _v is not None: write(_filter(_v, rawExpr='$message')) # from line 331, col 9.
                write('''<br />
''')
            write('''    </p>
    <p class="error">
''')
            for error in VFFSL(SL,"list.status.errors",True): # generated from line 335, col 1
                write('''        ''')
                _v = VFFSL(SL,"error",True) # '$error' on line 336, col 9
                if _v is not None: write(_filter(_v, rawExpr='$error')) # from line 336, col 9.
                write('''<br />
''')
            write('''    </p>
''')
        if VFFSL(SL,"list.isBulkList",True): # generated from line 340, col 1
            #  Show bulk preview legend
            write('''        <p>
            Legend
        </p>
        <p>
            <img src="''')
            _v = VFFSL(SL,"list.imgGreen",True) # '$list.imgGreen' on line 346, col 23
            if _v is not None: write(_filter(_v, rawExpr='$list.imgGreen')) # from line 346, col 23.
            write('''">&nbsp;''')
            _v = VFFSL(SL,"list.legendGreen",True) # '$list.legendGreen' on line 346, col 45
            if _v is not None: write(_filter(_v, rawExpr='$list.legendGreen')) # from line 346, col 45.
            write('''<br />
            <img src="''')
            _v = VFFSL(SL,"list.imgRed",True) # '$list.imgRed' on line 347, col 23
            if _v is not None: write(_filter(_v, rawExpr='$list.imgRed')) # from line 347, col 23.
            write('''">&nbsp;''')
            _v = VFFSL(SL,"list.legendRed",True) # '$list.legendRed' on line 347, col 43
            if _v is not None: write(_filter(_v, rawExpr='$list.legendRed')) # from line 347, col 43.
            write('''<br />
            <img src="''')
            _v = VFFSL(SL,"list.imgYellow",True) # '$list.imgYellow' on line 348, col 23
            if _v is not None: write(_filter(_v, rawExpr='$list.imgYellow')) # from line 348, col 23.
            write('''">&nbsp;''')
            _v = VFFSL(SL,"list.legendYellow",True) # '$list.legendYellow' on line 348, col 46
            if _v is not None: write(_filter(_v, rawExpr='$list.legendYellow')) # from line 348, col 46.
            write('''<br />
        </p>
''')
        write('''    <form method="''')
        _v = VFFSL(SL,"list.method",True) # '$list.method' on line 351, col 19
        if _v is not None: write(_filter(_v, rawExpr='$list.method')) # from line 351, col 19.
        write('''" action="''')
        _v = VFFSL(SL,"list.action",True) # '$list.action' on line 351, col 41
        if _v is not None: write(_filter(_v, rawExpr='$list.action')) # from line 351, col 41.
        write('''">
''')
        if VFFSL(SL,"list.hiddenIdValue",True): # generated from line 352, col 1
            write('''        <input type="hidden" name="''')
            _v = VFFSL(SL,"list.cnameHiddenId",True) # '$list.cnameHiddenId' on line 353, col 36
            if _v is not None: write(_filter(_v, rawExpr='$list.cnameHiddenId')) # from line 353, col 36.
            write('''" value="''')
            _v = VFFSL(SL,"list.hiddenIdValue",True) # '$list.hiddenIdValue' on line 353, col 64
            if _v is not None: write(_filter(_v, rawExpr='$list.hiddenIdValue')) # from line 353, col 64.
            write('''" />
''')
        if not VFFSL(SL,"list.isDeleteList",True): # generated from line 355, col 1
            write('''    ''')
            _v = VFFSL(SL,"actionBar",False)(VFFSL(SL,"list",True)) # '$actionBar($list)' on line 356, col 5
            if _v is not None: write(_filter(_v, rawExpr='$actionBar($list)')) # from line 356, col 5.
            write('''
''')
        write('''        <table border="0" cellspacing="0" cellpadding="0">
            <tr class="header">
                <td bgcolor="white" style="background-image:url(\'/images/ragen/navbar-start.gif\'); background-repeat: no-repeat; width: 14px">
''')
        for heading in VFFSL(SL,"list.headings",True): # generated from line 361, col 1
            write('''                <td valign="top">''')
            _v = VFFSL(SL,"heading",True) # '$heading' on line 362, col 34
            if _v is not None: write(_filter(_v, rawExpr='$heading')) # from line 362, col 34.
            write('''&nbsp;</td>
''')
        write('''                <td bgcolor="white" style="background-image:url(\'/images/ragen/navbar-end.gif\'); background-position: top right; background-repeat: no-repeat; width: 14px;">
            </tr>
''')
        odd = True
        for id,row in VFFSL(SL,"list.rows",True): # generated from line 367, col 1
            if VFFSL(SL,"odd",True): # generated from line 368, col 1
                rowtype = 'oddrow'
                odd = False
            else: # generated from line 371, col 1
                rowtype = 'evenrow'
                odd = True
            write('''            <tr class="''')
            _v = VFFSL(SL,"rowtype",True) # '$rowtype' on line 375, col 24
            if _v is not None: write(_filter(_v, rawExpr='$rowtype')) # from line 375, col 24.
            write('''">
                <td>&nbsp;</td> ''')
            #  first column is start gfx (fix)
            write('''
''')
            if not (VFFSL(SL,"list.isDeleteList",True) or VFFSL(SL,"list.isBulkList",True)): # generated from line 377, col 1
                write('''                <td><input type="checkbox" name="''')
                _v = VFFSL(SL,"list.cnameChk",True) # '$list.cnameChk' on line 378, col 50
                if _v is not None: write(_filter(_v, rawExpr='$list.cnameChk')) # from line 378, col 50.
                write('''" value="''')
                _v = VFFSL(SL,"id",True) # '$id' on line 378, col 73
                if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 378, col 73.
                write('''" align="center" />&nbsp;&nbsp;</td>
''')
            elif VFFSL(SL,"list.isDeleteList",True): # generated from line 379, col 1
                write('''                <input type="hidden" name="''')
                _v = VFFSL(SL,"list.cnameChk",True) # '$list.cnameChk' on line 380, col 44
                if _v is not None: write(_filter(_v, rawExpr='$list.cnameChk')) # from line 380, col 44.
                write('''" value="''')
                _v = VFFSL(SL,"id",True) # '$id' on line 380, col 67
                if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 380, col 67.
                write('''" />
''')
            for entry,link in VFFSL(SL,"row",True): # generated from line 382, col 1
                if VFFSL(SL,"link",True): # generated from line 383, col 1
                    write('''                <td><a href="''')
                    _v = VFFSL(SL,"link",True) # '$link' on line 384, col 30
                    if _v is not None: write(_filter(_v, rawExpr='$link')) # from line 384, col 30.
                    write('''">''')
                    _v = VFFSL(SL,"entry",True)[0] # '$entry[0]' on line 384, col 37
                    if _v is not None: write(_filter(_v, rawExpr='$entry[0]')) # from line 384, col 37.
                    write('''</a>&nbsp;&nbsp;</td>
''')
                else: # generated from line 385, col 1
                    write('''                <td>
''')
                    for line in VFFSL(SL,"entry",True): # generated from line 387, col 1
                        write('''                    ''')
                        _v = VFFSL(SL,"line",True) # '$line' on line 388, col 21
                        if _v is not None: write(_filter(_v, rawExpr='$line')) # from line 388, col 21.
                        write('''&nbsp;&nbsp;<br />
''')
                    write('''                </td>
''')
            write('''                <td>&nbsp;</td> ''')
            #  last column is end gfx (fix)
            write('''
            </tr>
''')
        write('''        </table>
    ''')
        _v = VFFSL(SL,"actionBar",False)(VFFSL(SL,"list",True)) # '$actionBar($list)' on line 397, col 5
        if _v is not None: write(_filter(_v, rawExpr='$actionBar($list)')) # from line 397, col 5.
        write('''
''')
        if VFFSL(SL,"list.isBulkList",True): # generated from line 398, col 1
            for name,value in VFFSL(SL,"list.hiddenData",True): # generated from line 399, col 1
                write('''    <input type="hidden" name="''')
                _v = VFFSL(SL,"name",True) # '$name' on line 400, col 32
                if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 400, col 32.
                write('''" value="''')
                _v = VFFSL(SL,"value",True) # '$value' on line 400, col 46
                if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 400, col 46.
                write('''" />
''')
        write('''    </form>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def actionBar(self, list, **KWS):



        ## CHEETAH: generated from #def actionBar($list) at line 407, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''    <p>
        <table>
            <tr>
''')
        if not (VFFSL(SL,"list.isDeleteList",True) or VFFSL(SL,"list.isBulkList",True)): # generated from line 411, col 1
            write('''                <td><input type="submit" name="''')
            _v = VFFSL(SL,"list.cnameAdd",True) # '$list.cnameAdd' on line 412, col 48
            if _v is not None: write(_filter(_v, rawExpr='$list.cnameAdd')) # from line 412, col 48.
            write('''" value="''')
            _v = VFFSL(SL,"list.textAdd",True) # '$list.textAdd' on line 412, col 71
            if _v is not None: write(_filter(_v, rawExpr='$list.textAdd')) # from line 412, col 71.
            write('''" /></td>
                <td><input type="submit" name="''')
            _v = VFFSL(SL,"list.cnameEdit",True) # '$list.cnameEdit' on line 413, col 48
            if _v is not None: write(_filter(_v, rawExpr='$list.cnameEdit')) # from line 413, col 48.
            write('''" value="''')
            _v = VFFSL(SL,"list.textEdit",True) # '$list.textEdit' on line 413, col 72
            if _v is not None: write(_filter(_v, rawExpr='$list.textEdit')) # from line 413, col 72.
            write('''" /></td>
                <td><input type="submit" name="''')
            _v = VFFSL(SL,"list.cnameDelete",True) # '$list.cnameDelete' on line 414, col 48
            if _v is not None: write(_filter(_v, rawExpr='$list.cnameDelete')) # from line 414, col 48.
            write('''" value="''')
            _v = VFFSL(SL,"list.textDelete",True) # '$list.textDelete' on line 414, col 74
            if _v is not None: write(_filter(_v, rawExpr='$list.textDelete')) # from line 414, col 74.
            write('''" /></td>
''')
        elif VFFSL(SL,"list.isDeleteList",True): # generated from line 415, col 1
            write('''                <td><input type="submit" name="''')
            _v = VFFSL(SL,"list.cnameDeleteConfirm",True) # '$list.cnameDeleteConfirm' on line 416, col 48
            if _v is not None: write(_filter(_v, rawExpr='$list.cnameDeleteConfirm')) # from line 416, col 48.
            write('''" value="''')
            _v = VFFSL(SL,"list.textDeleteConfirm",True) # '$list.textDeleteConfirm' on line 416, col 81
            if _v is not None: write(_filter(_v, rawExpr='$list.textDeleteConfirm')) # from line 416, col 81.
            write('''" /></td>
''')
        elif VFFSL(SL,"list.isBulkList",True): # generated from line 417, col 1
            write('''                <td><input type="submit" name="''')
            _v = VFFSL(SL,"list.cnameBulkConfirm",True) # '$list.cnameBulkConfirm' on line 418, col 48
            if _v is not None: write(_filter(_v, rawExpr='$list.cnameBulkConfirm')) # from line 418, col 48.
            write('''" value="''')
            _v = VFFSL(SL,"list.textBulkConfirm",True) # '$list.textBulkConfirm' on line 418, col 79
            if _v is not None: write(_filter(_v, rawExpr='$list.textBulkConfirm')) # from line 418, col 79.
            write('''" /></td>
''')
        write('''            </tr>
        </table>
    </p>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def showForm(self, form, **KWS):



        ## CHEETAH: generated from #def showForm($form) at line 426, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''    <h3>''')
        _v = VFFSL(SL,"form.title",True) # '$form.title' on line 427, col 9
        if _v is not None: write(_filter(_v, rawExpr='$form.title')) # from line 427, col 9.
        write('''</h3>
''')
        if VFFSL(SL,"form.status",True): # generated from line 428, col 1
            write('''    <p class="status">
''')
            for message in VFFSL(SL,"form.status.messages",True): # generated from line 430, col 1
                write('''        ''')
                _v = VFFSL(SL,"message",True) # '$message' on line 431, col 9
                if _v is not None: write(_filter(_v, rawExpr='$message')) # from line 431, col 9.
                write('''<br />
''')
            write('''    </p>
    <p class="error">
''')
            for error in VFFSL(SL,"form.status.errors",True): # generated from line 435, col 1
                write('''        ''')
                _v = VFFSL(SL,"error",True) # '$error' on line 436, col 9
                if _v is not None: write(_filter(_v, rawExpr='$error')) # from line 436, col 9.
                write('''<br />
''')
            write('''    </p>
''')
        write('''    <form method="''')
        _v = VFFSL(SL,"form.method",True) # '$form.method' on line 440, col 19
        if _v is not None: write(_filter(_v, rawExpr='$form.method')) # from line 440, col 19.
        write('''" action="''')
        _v = VFFSL(SL,"form.action",True) # '$form.action' on line 440, col 41
        if _v is not None: write(_filter(_v, rawExpr='$form.action')) # from line 440, col 41.
        write('''" enctype="''')
        _v = VFFSL(SL,"form.enctype",True) # '$form.enctype' on line 440, col 64
        if _v is not None: write(_filter(_v, rawExpr='$form.enctype')) # from line 440, col 64.
        write('''">
''')
        for editbox in VFFSL(SL,"form.editboxes",True): # generated from line 441, col 1
            write('''        <input type="hidden" name="''')
            _v = VFFSL(SL,"editbox.boxName",True) # '$editbox.boxName' on line 442, col 36
            if _v is not None: write(_filter(_v, rawExpr='$editbox.boxName')) # from line 442, col 36.
            write('''" value="''')
            _v = VFFSL(SL,"editbox.boxId",True) # '$editbox.boxId' on line 442, col 61
            if _v is not None: write(_filter(_v, rawExpr='$editbox.boxId')) # from line 442, col 61.
            write('''" />
        <p>
''')
            if VFFSL(SL,"editbox.page",True) == 'room': # generated from line 444, col 1
                write('''            ''')
                _v = VFFSL(SL,"room",False)(VFFSL(SL,"editbox",True)) # '$room($editbox)' on line 445, col 13
                if _v is not None: write(_filter(_v, rawExpr='$room($editbox)')) # from line 445, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'container': # generated from line 446, col 1
                write('''            ''')
                _v = VFFSL(SL,"container",False)(VFFSL(SL,"editbox",True)) # '$container($editbox)' on line 447, col 13
                if _v is not None: write(_filter(_v, rawExpr='$container($editbox)')) # from line 447, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'location': # generated from line 448, col 1
                write('''            ''')
                _v = VFFSL(SL,"location",False)(VFFSL(SL,"editbox",True)) # '$location($editbox)' on line 449, col 13
                if _v is not None: write(_filter(_v, rawExpr='$location($editbox)')) # from line 449, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'org': # generated from line 450, col 1
                write('''            ''')
                _v = VFFSL(SL,"org",False)(VFFSL(SL,"editbox",True)) # '$org($editbox)' on line 451, col 13
                if _v is not None: write(_filter(_v, rawExpr='$org($editbox)')) # from line 451, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'type': # generated from line 452, col 1
                write('''            ''')
                _v = VFFSL(SL,"typebox",False)(VFFSL(SL,"editbox",True)) # '$typebox($editbox)' on line 453, col 13
                if _v is not None: write(_filter(_v, rawExpr='$typebox($editbox)')) # from line 453, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'vendor': # generated from line 454, col 1
                write('''            ''')
                _v = VFFSL(SL,"vendor",False)(VFFSL(SL,"editbox",True)) # '$vendor($editbox)' on line 455, col 13
                if _v is not None: write(_filter(_v, rawExpr='$vendor($editbox)')) # from line 455, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'netbox': # generated from line 456, col 1
                write('''            ''')
                _v = VFFSL(SL,"netbox",False)(VFFSL(SL,"editbox",True)) # '$netbox($editbox)' on line 457, col 13
                if _v is not None: write(_filter(_v, rawExpr='$netbox($editbox)')) # from line 457, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'netboxserial': # generated from line 458, col 1
                write('''            ''')
                _v = VFFSL(SL,"netboxserial",False)(VFFSL(SL,"editbox",True)) # '$netboxserial($editbox)' on line 459, col 13
                if _v is not None: write(_filter(_v, rawExpr='$netboxserial($editbox)')) # from line 459, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'netboxcategory': # generated from line 460, col 1
                write('''            ''')
                _v = VFFSL(SL,"netboxcategory",False)(VFFSL(SL,"editbox",True)) # '$netboxcategory($editbox)' on line 461, col 13
                if _v is not None: write(_filter(_v, rawExpr='$netboxcategory($editbox)')) # from line 461, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'netboxproduct': # generated from line 462, col 1
                write('''            ''')
                _v = VFFSL(SL,"netboxproduct",False)(VFFSL(SL,"editbox",True)) # '$netboxproduct($editbox)' on line 463, col 13
                if _v is not None: write(_filter(_v, rawExpr='$netboxproduct($editbox)')) # from line 463, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'bulk': # generated from line 464, col 1
                write('''            ''')
                _v = VFFSL(SL,"bulk",False)(VFFSL(SL,"editbox",True)) # '$bulk($editbox)' on line 465, col 13
                if _v is not None: write(_filter(_v, rawExpr='$bulk($editbox)')) # from line 465, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'usage': # generated from line 466, col 1
                write('''            ''')
                _v = VFFSL(SL,"usage",False)(VFFSL(SL,"editbox",True)) # '$usage($editbox)' on line 467, col 13
                if _v is not None: write(_filter(_v, rawExpr='$usage($editbox)')) # from line 467, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'service': # generated from line 468, col 1
                write('''            ''')
                _v = VFFSL(SL,"service",False)(VFFSL(SL,"editbox",True)) # '$service($editbox)' on line 469, col 13
                if _v is not None: write(_filter(_v, rawExpr='$service($editbox)')) # from line 469, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'product': # generated from line 470, col 1
                write('''            ''')
                _v = VFFSL(SL,"product",False)(VFFSL(SL,"editbox",True)) # '$product($editbox)' on line 471, col 13
                if _v is not None: write(_filter(_v, rawExpr='$product($editbox)')) # from line 471, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'prefix': # generated from line 472, col 1
                write('''            ''')
                _v = VFFSL(SL,"prefix",False)(VFFSL(SL,"editbox",True)) # '$prefix($editbox)' on line 473, col 13
                if _v is not None: write(_filter(_v, rawExpr='$prefix($editbox)')) # from line 473, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'ric': # generated from line 474, col 1
                write('''            ''')
                _v = VFFSL(SL,"ric",False)(VFFSL(SL,"editbox",True)) # '$ric($editbox)' on line 475, col 13
                if _v is not None: write(_filter(_v, rawExpr='$ric($editbox)')) # from line 475, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'vlan': # generated from line 476, col 1
                write('''            ''')
                _v = VFFSL(SL,"vlan",False)(VFFSL(SL,"editbox",True)) # '$vlan($editbox)' on line 477, col 13
                if _v is not None: write(_filter(_v, rawExpr='$vlan($editbox)')) # from line 477, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'subcat': # generated from line 478, col 1
                write('''            ''')
                _v = VFFSL(SL,"subcat",False)(VFFSL(SL,"editbox",True)) # '$subcat($editbox)' on line 479, col 13
                if _v is not None: write(_filter(_v, rawExpr='$subcat($editbox)')) # from line 479, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'snmpoid': # generated from line 480, col 1
                write('''            ''')
                _v = VFFSL(SL,"snmpoid",False)(VFFSL(SL,"editbox",True)) # '$snmpoid($editbox)' on line 481, col 13
                if _v is not None: write(_filter(_v, rawExpr='$snmpoid($editbox)')) # from line 481, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'hiddenormessage': # generated from line 482, col 1
                write('''            ''')
                _v = VFFSL(SL,"hiddenormessage",False)(VFFSL(SL,"editbox",True)) # '$hiddenormessage($editbox)' on line 483, col 13
                if _v is not None: write(_filter(_v, rawExpr='$hiddenormessage($editbox)')) # from line 483, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'cabling': # generated from line 484, col 1
                write('''            ''')
                _v = VFFSL(SL,"cabling",False)(VFFSL(SL,"editbox",True)) # '$cabling($editbox)' on line 485, col 13
                if _v is not None: write(_filter(_v, rawExpr='$cabling($editbox)')) # from line 485, col 13.
                write('''
''')
            elif VFFSL(SL,"editbox.page",True) == 'patch': # generated from line 486, col 1
                write('''            ''')
                _v = VFFSL(SL,"patch",False)(VFFSL(SL,"editbox",True)) # '$patch($editbox)' on line 487, col 13
                if _v is not None: write(_filter(_v, rawExpr='$patch($editbox)')) # from line 487, col 13.
                write('''
''')
            write('''        </p>
''')
        if VFFSL(SL,"form.showConfirm",True): # generated from line 491, col 1
            write('''        <table>
            <tr>
                <td><input type="submit" name="''')
            _v = VFFSL(SL,"form.cnameConfirm",True) # '$form.cnameConfirm' on line 494, col 48
            if _v is not None: write(_filter(_v, rawExpr='$form.cnameConfirm')) # from line 494, col 48.
            write('''" value="''')
            _v = VFFSL(SL,"form.textConfirm",True) # '$form.textConfirm' on line 494, col 75
            if _v is not None: write(_filter(_v, rawExpr='$form.textConfirm')) # from line 494, col 75.
            write('''" /></td>
''')
            if VFFSL(SL,"form.showCancel",True): # generated from line 495, col 1
                write('''                <td><input type="submit" name="''')
                _v = VFFSL(SL,"form.cnameCancel",True) # '$form.cnameCancel' on line 496, col 48
                if _v is not None: write(_filter(_v, rawExpr='$form.cnameCancel')) # from line 496, col 48.
                write('''" value="''')
                _v = VFFSL(SL,"form.textCancel",True) # '$form.textCancel' on line 496, col 74
                if _v is not None: write(_filter(_v, rawExpr='$form.textCancel')) # from line 496, col 74.
                write('''" /></td>
''')
            if VFFSL(SL,"form.showDelete",True) and VFFSL(SL,"editbox.page",True) == 'netbox' and VFFSL(SL,"form.action",True) != 'add': # generated from line 498, col 1
                write('''                <td><input type="submit" name="''')
                _v = VFFSL(SL,"form.cnameDelete",True) # '$form.cnameDelete' on line 499, col 48
                if _v is not None: write(_filter(_v, rawExpr='$form.cnameDelete')) # from line 499, col 48.
                write('''" value="''')
                _v = VFFSL(SL,"form.textDelete",True) # '$form.textDelete' on line 499, col 74
                if _v is not None: write(_filter(_v, rawExpr='$form.textDelete')) # from line 499, col 74.
                write('''" /></td>
''')
            write('''            </tr>
        </table>
    </form>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def patch(self, editbox, **KWS):



        ## CHEETAH: generated from #def patch($editbox) at line 514, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <p>
        ''')
        _v = VFFSL(SL,"editbox.help",True) # '$editbox.help' on line 517, col 9
        if _v is not None: write(_filter(_v, rawExpr='$editbox.help')) # from line 517, col 9.
        write('''
    </p>
    <div style="border: 1px solid #666; background-image:url(\'/images/form/fill-active.gif\');   background-color:#ccf; font-size: 13px; padding-top: 1em; padding-bottom: 1em; padding-left: 1em;">
        <p>
            ''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['box1']) # "$input($fields['box1'])" on line 521, col 13
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['box1'])")) # from line 521, col 13.
        write('''
        </p>
        <p>
            <h3>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['split']) # "$heading($fields['split'])" on line 524, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['split'])")) # from line 524, col 17.
        write('''</h3>
            ''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['split']) # "$input($fields['split'])" on line 525, col 13
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['split'])")) # from line 525, col 13.
        write('''
        </p>
        <p>
            ''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['box2']) # "$input($fields['box2'])" on line 528, col 13
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['box2'])")) # from line 528, col 13.
        write('''
        </p>
    </div>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def cabling(self, editbox, **KWS):



        ## CHEETAH: generated from #def cabling($editbox) at line 534, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <p>
        <table class="header-active">
            <tr>
                <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['roomid']) # "$heading($fields['roomid'])" on line 539, col 33
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['roomid'])")) # from line 539, col 33.
        write('''</th>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['jack']) # "$heading($fields['jack'])" on line 540, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['jack'])")) # from line 540, col 21.
        write('''</th>
            </tr>
            <tr>
                <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['roomid']) # "$input($fields['roomid'])" on line 543, col 33
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['roomid'])")) # from line 543, col 33.
        write('''</td>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['jack']) # "$input($fields['jack'])" on line 544, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['jack'])")) # from line 544, col 21.
        write('''</td>
            </tr>
            <tr>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['building']) # "$heading($fields['building'])" on line 547, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['building'])")) # from line 547, col 21.
        write('''</th>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['targetroom']) # "$heading($fields['targetroom'])" on line 548, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['targetroom'])")) # from line 548, col 21.
        write('''</th>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['category']) # "$heading($fields['category'])" on line 549, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['category'])")) # from line 549, col 21.
        write('''</th>
            </tr>
            <tr>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['building'],'width: 100%;') # "$input($fields['building'],'width: 100%;')" on line 552, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['building'],'width: 100%;')")) # from line 552, col 21.
        write('''</td>
                <td align="center">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['targetroom']) # "$input($fields['targetroom'])" on line 553, col 36
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['targetroom'])")) # from line 553, col 36.
        write('''</td>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['category']) # "$input($fields['category'])" on line 554, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['category'])")) # from line 554, col 21.
        write('''</td>
            </tr>
            <tr>
                <th colspan="3">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 557, col 33
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 557, col 33.
        write('''</th>
            </tr>
            <tr>
                <td colspan="3">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 560, col 33
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 560, col 33.
        write('''</td>
            </tr>
        </table>
    </p>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def netboxserial(self, editbox, **KWS):



        ## CHEETAH: generated from #def netboxserial($editbox) at line 567, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <p>
        <table class="header-active">
            <tr>
                <td>Sysname</td>
                <td>''')
        _v = VFFSL(SL,"editbox.sysname",True) # '$editbox.sysname' on line 573, col 21
        if _v is not None: write(_filter(_v, rawExpr='$editbox.sysname')) # from line 573, col 21.
        write('''</td>
            </tr>
            <tr>
                <td>Type</td>
                <td>''')
        _v = VFFSL(SL,"editbox.typename",True) # '$editbox.typename' on line 577, col 21
        if _v is not None: write(_filter(_v, rawExpr='$editbox.typename')) # from line 577, col 21.
        write('''</td>
            </tr>
            <tr>
                <td>SNMP version</td>
                <td>''')
        _v = VFFSL(SL,"editbox.snmpversion",True) # '$editbox.snmpversion' on line 581, col 21
        if _v is not None: write(_filter(_v, rawExpr='$editbox.snmpversion')) # from line 581, col 21.
        write('''</td>
            </tr>
        </table>
    </p>
    <p>''')
        _v = VFFSL(SL,"editbox.help",True) # '$editbox.help' on line 585, col 8
        if _v is not None: write(_filter(_v, rawExpr='$editbox.help')) # from line 585, col 8.
        write('''</p>
    <p>
        <table class="header-active">
            <tr>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['serial']) # "$heading($fields['serial'])" on line 589, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['serial'])")) # from line 589, col 21.
        write('''</th>
            </tr>
            <tr>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['serial']) # "$input($fields['serial'])" on line 592, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['serial'])")) # from line 592, col 21.
        write('''</td>
            </tr>
        </table>
    </p>
<!-- def netboxserial -->
''')
        _v = VFFSL(SL,"hiddenfields",False)(VFFSL(SL,"editbox.hiddenFields",True)) # '$hiddenfields($editbox.hiddenFields)' on line 597, col 1
        if _v is not None: write(_filter(_v, rawExpr='$hiddenfields($editbox.hiddenFields)')) # from line 597, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def netboxcategory(self, editbox, **KWS):



        ## CHEETAH: generated from #def netboxcategory($editbox) at line 601, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <p>''')
        _v = VFFSL(SL,"editbox.help",True) # '$editbox.help' on line 603, col 8
        if _v is not None: write(_filter(_v, rawExpr='$editbox.help')) # from line 603, col 8.
        write('''</p>
    <p>
        <table class="header-active">
''')
        if VFN(VFFSL(SL,"fields",True),"has_key",False)('subcat'): # generated from line 606, col 1
            write('''            <tr>
                <th>''')
            _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['subcat']) # "$heading($fields['subcat'])" on line 608, col 21
            if _v is not None: write(_filter(_v, rawExpr="$heading($fields['subcat'])")) # from line 608, col 21.
            write('''</th>
            </tr>
            <tr>
                <td>''')
            _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['subcat'],'width: 100%;') # "$input($fields['subcat'],'width: 100%;')" on line 611, col 21
            if _v is not None: write(_filter(_v, rawExpr="$input($fields['subcat'],'width: 100%;')")) # from line 611, col 21.
            write('''</td>
            </tr>
''')
        write('''            <tr>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['function']) # "$heading($fields['function'])" on line 615, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['function'])")) # from line 615, col 21.
        write('''</th>
            </tr>
            <tr>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['function']) # "$input($fields['function'])" on line 618, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['function'])")) # from line 618, col 21.
        write('''</td>
            </tr>
        </table>
    </p>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def netbox(self, editbox, **KWS):



        ## CHEETAH: generated from #def netbox($editbox) at line 625, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        if VFFSL(SL,"editbox.editId",True): # generated from line 627, col 1
            write('''    <h3>''')
            _v = VFFSL(SL,"editbox.sysname",True) # '$editbox.sysname' on line 628, col 9
            if _v is not None: write(_filter(_v, rawExpr='$editbox.sysname')) # from line 628, col 9.
            write('''</h3>
''')
        write('''        <table class="header-active">
            <tr>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['ip']) # "$heading($fields['ip'])" on line 632, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['ip'])")) # from line 632, col 21.
        write('''</th>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['catid']) # "$heading($fields['catid'])" on line 633, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['catid'])")) # from line 633, col 21.
        write('''</th>
            </tr>
            <tr>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['ip']) # "$input($fields['ip'])" on line 636, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['ip'])")) # from line 636, col 21.
        write('''</td>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['catid'],style='width: 100%;') # "$input($fields['catid'],style='width: 100%;')" on line 637, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['catid'],style='width: 100%;')")) # from line 637, col 21.
        write('''</td>
            </tr>
            <tr>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['ro']) # "$heading($fields['ro'])" on line 640, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['ro'])")) # from line 640, col 21.
        write('''</th>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['roomid']) # "$heading($fields['roomid'])" on line 641, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['roomid'])")) # from line 641, col 21.
        write('''</th>
            </tr>
            <tr>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['ro']) # "$input($fields['ro'])" on line 644, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['ro'])")) # from line 644, col 21.
        write('''</td>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['roomid'],style='width: 100%;') # "$input($fields['roomid'],style='width: 100%;')" on line 645, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['roomid'],style='width: 100%;')")) # from line 645, col 21.
        write('''</td>
            </tr>
            <tr>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['rw']) # "$heading($fields['rw'])" on line 648, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['rw'])")) # from line 648, col 21.
        write('''</th>
                <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['orgid']) # "$heading($fields['orgid'])" on line 649, col 21
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['orgid'])")) # from line 649, col 21.
        write('''</th>
            </tr>
            <tr>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['rw']) # "$input($fields['rw'])" on line 652, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['rw'])")) # from line 652, col 21.
        write('''</td>
                <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['orgid']) # "$input($fields['orgid'])" on line 653, col 21
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['orgid'])")) # from line 653, col 21.
        write('''</td>
            </tr>
        </table>
<!-- def netbox -->
''')
        _v = VFFSL(SL,"hiddenfields",False)(VFFSL(SL,"editbox.hiddenFields",True)) # '$hiddenfields($editbox.hiddenFields)' on line 657, col 1
        if _v is not None: write(_filter(_v, rawExpr='$hiddenfields($editbox.hiddenFields)')) # from line 657, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def snmpoid(self, editbox, **KWS):



        ## CHEETAH: generated from #def snmpoid($editbox) at line 661, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['oidkey']) # "$heading($fields['oidkey'])" on line 665, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['oidkey'])")) # from line 665, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['snmpoid']) # "$heading($fields['snmpoid'])" on line 666, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['snmpoid'])")) # from line 666, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['oidsource']) # "$heading($fields['oidsource'])" on line 667, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['oidsource'])")) # from line 667, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['match_regex']) # "$heading($fields['match_regex'])" on line 668, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['match_regex'])")) # from line 668, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['oidkey']) # "$input($fields['oidkey'])" on line 671, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['oidkey'])")) # from line 671, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['snmpoid']) # "$input($fields['snmpoid'])" on line 672, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['snmpoid'])")) # from line 672, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['oidsource']) # "$input($fields['oidsource'])" on line 673, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['oidsource'])")) # from line 673, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['match_regex']) # "$input($fields['match_regex'])" on line 674, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['match_regex'])")) # from line 674, col 17.
        write('''</td>
        </tr>
        <tr>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['oidname']) # "$heading($fields['oidname'])" on line 677, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['oidname'])")) # from line 677, col 29.
        write('''</th>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['mib']) # "$heading($fields['mib'])" on line 678, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['mib'])")) # from line 678, col 29.
        write('''</th>
        </tr>
        <tr>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['oidname'],'width: 100%;') # "$input($fields['oidname'],'width: 100%;')" on line 681, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['oidname'],'width: 100%;')")) # from line 681, col 29.
        write('''</td>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['mib'],'width: 100%;') # "$input($fields['mib'],'width: 100%;')" on line 682, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['mib'],'width: 100%;')")) # from line 682, col 29.
        write('''</td>
        </tr>
        <tr>
            <th colspan="4">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 685, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 685, col 29.
        write('''</th>
        </tr>
        <tr>
            <td colspan="4">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 688, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 688, col 29.
        write('''</td>
        </tr>
    </table>
''')
        _v = VFFSL(SL,"hiddenfields",False)(VFFSL(SL,"editbox.hiddenFields",True)) # '$hiddenfields($editbox.hiddenFields)' on line 691, col 1
        if _v is not None: write(_filter(_v, rawExpr='$hiddenfields($editbox.hiddenFields)')) # from line 691, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def room(self, editbox, **KWS):



        ## CHEETAH: generated from #def room($editbox) at line 698, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['roomid']) # "$heading($fields['roomid'])" on line 702, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['roomid'])")) # from line 702, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['locationid']) # "$heading($fields['locationid'])" on line 703, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['locationid'])")) # from line 703, col 17.
        write('''</th>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 704, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 704, col 29.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['roomid']) # "$input($fields['roomid'])" on line 707, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['roomid'])")) # from line 707, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['locationid']) # "$input($fields['locationid'])" on line 708, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['locationid'])")) # from line 708, col 17.
        write('''</td>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 709, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 709, col 29.
        write('''</td>
        </tr>
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['opt1']) # "$heading($fields['opt1'])" on line 712, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['opt1'])")) # from line 712, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['opt2']) # "$heading($fields['opt2'])" on line 713, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['opt2'])")) # from line 713, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['opt3']) # "$heading($fields['opt3'])" on line 714, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['opt3'])")) # from line 714, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['opt4']) # "$heading($fields['opt4'])" on line 715, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['opt4'])")) # from line 715, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['opt1']) # "$input($fields['opt1'])" on line 718, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['opt1'])")) # from line 718, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['opt2'],'width: 100%;') # "$input($fields['opt2'],'width: 100%;')" on line 719, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['opt2'],'width: 100%;')")) # from line 719, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['opt3']) # "$input($fields['opt3'])" on line 720, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['opt3'])")) # from line 720, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['opt4']) # "$input($fields['opt4'])" on line 721, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['opt4'])")) # from line 721, col 17.
        write('''</td>
        </tr>
    </table>
''')
        _v = VFFSL(SL,"hiddenfields",False)(VFFSL(SL,"editbox.hiddenFields",True)) # '$hiddenfields($editbox.hiddenFields)' on line 724, col 1
        if _v is not None: write(_filter(_v, rawExpr='$hiddenfields($editbox.hiddenFields)')) # from line 724, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def location(self, editbox, **KWS):



        ## CHEETAH: generated from #def location($editbox) at line 728, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active" width="50%">
        <tr>
            <th width="30%">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['locationid']) # "$heading($fields['locationid'])" on line 732, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['locationid'])")) # from line 732, col 29.
        write('''</th>
            <th width="70%">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 733, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 733, col 29.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['locationid'],'width: 100%;') # "$input($fields['locationid'],'width: 100%;')" on line 736, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['locationid'],'width: 100%;')")) # from line 736, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 737, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 737, col 17.
        write('''</td>
        </tr>
    </table>
''')
        _v = VFFSL(SL,"hiddenfields",False)(VFFSL(SL,"editbox.hiddenFields",True)) # '$hiddenfields($editbox.hiddenFields)' on line 740, col 1
        if _v is not None: write(_filter(_v, rawExpr='$hiddenfields($editbox.hiddenFields)')) # from line 740, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def org(self, editbox, **KWS):



        ## CHEETAH: generated from #def org($editbox) at line 744, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['orgid']) # "$heading($fields['orgid'])" on line 748, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['orgid'])")) # from line 748, col 17.
        write('''</th>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['parent']) # "$heading($fields['parent'])" on line 749, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['parent'])")) # from line 749, col 29.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['orgid']) # "$input($fields['orgid'])" on line 752, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['orgid'])")) # from line 752, col 17.
        write('''</td>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['parent']) # "$input($fields['parent'])" on line 753, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['parent'])")) # from line 753, col 29.
        write('''</td>
        </tr>
        <tr>
            <th colspan="3">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 756, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 756, col 29.
        write('''</th>
        </tr>
        <tr>
            <td colspan="3">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 759, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 759, col 29.
        write('''</td>
        </tr>
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['opt1']) # "$heading($fields['opt1'])" on line 762, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['opt1'])")) # from line 762, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['opt2']) # "$heading($fields['opt2'])" on line 763, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['opt2'])")) # from line 763, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['opt3']) # "$heading($fields['opt3'])" on line 764, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['opt3'])")) # from line 764, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['opt1']) # "$input($fields['opt1'])" on line 767, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['opt1'])")) # from line 767, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['opt2']) # "$input($fields['opt2'])" on line 768, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['opt2'])")) # from line 768, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['opt3']) # "$input($fields['opt3'])" on line 769, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['opt3'])")) # from line 769, col 17.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def typebox(self, editbox, **KWS):



        ## CHEETAH: generated from #def typebox($editbox) at line 775, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active" width="60%">
        <tr>
            <th colspan="3" width="30%">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['typename']) # "$heading($fields['typename'])" on line 779, col 41
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['typename'])")) # from line 779, col 41.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 780, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 780, col 17.
        write('''</th>
        </tr>
        <tr>
            <td colspan="3">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['typename'],'width: 100%;') # "$input($fields['typename'],'width: 100%;')" on line 783, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['typename'],'width: 100%;')")) # from line 783, col 29.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 784, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 784, col 17.
        write('''</td>
        <tr>
            <th colspan="3">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vendorid']) # "$heading($fields['vendorid'])" on line 786, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vendorid'])")) # from line 786, col 29.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['sysobjectid']) # "$heading($fields['sysobjectid'])" on line 787, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['sysobjectid'])")) # from line 787, col 17.
        write('''</th>
        </tr>
            <td colspan="3">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vendorid'],'width: 100%;') # "$input($fields['vendorid'],'width: 100%;')" on line 789, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vendorid'],'width: 100%;')")) # from line 789, col 29.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['sysobjectid'],'width: 100%') # "$input($fields['sysobjectid'],'width: 100%')" on line 790, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['sysobjectid'],'width: 100%')")) # from line 790, col 17.
        write('''</td>
        </tr>
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['cdp']) # "$heading($fields['cdp'])" on line 793, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['cdp'])")) # from line 793, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['tftp']) # "$heading($fields['tftp'])" on line 794, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['tftp'])")) # from line 794, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['frequency']) # "$heading($fields['frequency'])" on line 795, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['frequency'])")) # from line 795, col 17.
        write('''</th>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td align="center">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['cdp']) # "$input($fields['cdp'])" on line 799, col 32
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['cdp'])")) # from line 799, col 32.
        write('''</td>
            <td align="center">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['tftp']) # "$input($fields['tftp'])" on line 800, col 32
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['tftp'])")) # from line 800, col 32.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['frequency']) # "$input($fields['frequency'])" on line 801, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['frequency'])")) # from line 801, col 17.
        write('''</td>
            <td>&nbsp;</td>
        </tr>
</table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def product(self, editbox, **KWS):



        ## CHEETAH: generated from #def product($editbox) at line 808, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        if VFN(VFFSL(SL,"fields",True),"has_key",False)('productid'): # generated from line 810, col 1
            _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['productid']) # "$input($fields['productid'])" on line 811, col 1
            if _v is not None: write(_filter(_v, rawExpr="$input($fields['productid'])")) # from line 811, col 1.
            write('''
''')
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vendorid']) # "$heading($fields['vendorid'])" on line 815, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vendorid'])")) # from line 815, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['productno']) # "$heading($fields['productno'])" on line 816, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['productno'])")) # from line 816, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vendorid']) # "$input($fields['vendorid'])" on line 819, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vendorid'])")) # from line 819, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['productno']) # "$input($fields['productno'])" on line 820, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['productno'])")) # from line 820, col 17.
        write('''</td>
        </tr>
        <tr>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 823, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 823, col 29.
        write('''</th>
        </tr>
        <tr>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 826, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 826, col 29.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def container(self, editbox, **KWS):



        ## CHEETAH: generated from #def container($editbox) at line 832, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['name']) # "$heading($fields['name'])" on line 836, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['name'])")) # from line 836, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['name']) # "$input($fields['name'])" on line 839, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['name'])")) # from line 839, col 17.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def ric(self, editbox, **KWS):



        ## CHEETAH: generated from #def ric($editbox) at line 845, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['container']) # "$heading($fields['container'])" on line 849, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['container'])")) # from line 849, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['routers']) # "$heading($fields['routers'])" on line 850, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['routers'])")) # from line 850, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['container']) # "$input($fields['container'])" on line 853, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['container'])")) # from line 853, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['routers']) # "$input($fields['routers'])" on line 854, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['routers'])")) # from line 854, col 17.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def vendor(self, editbox, **KWS):



        ## CHEETAH: generated from #def vendor($editbox) at line 863, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vendorid']) # "$heading($fields['vendorid'])" on line 867, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vendorid'])")) # from line 867, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vendorid']) # "$input($fields['vendorid'])" on line 870, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vendorid'])")) # from line 870, col 17.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def usage(self, editbox, **KWS):



        ## CHEETAH: generated from #def usage($editbox) at line 876, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['usageid']) # "$heading($fields['usageid'])" on line 880, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['usageid'])")) # from line 880, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 881, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 881, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['usageid']) # "$input($fields['usageid'])" on line 884, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['usageid'])")) # from line 884, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr']) # "$input($fields['descr'])" on line 885, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'])")) # from line 885, col 17.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def service(self, editbox, **KWS):



        ## CHEETAH: generated from #def service($editbox) at line 891, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <p>''')
        _v = VFFSL(SL,"editbox.help",True) # '$editbox.help' on line 893, col 8
        if _v is not None: write(_filter(_v, rawExpr='$editbox.help')) # from line 893, col 8.
        write('''</p>
    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['boxid']) # "$heading($fields['boxid'])" on line 896, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['boxid'])")) # from line 896, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['handler']) # "$heading($fields['handler'])" on line 897, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['handler'])")) # from line 897, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['boxid']) # "$input($fields['boxid'])" on line 900, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['boxid'])")) # from line 900, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['handler']) # "$input($fields['handler'])" on line 901, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['handler'])")) # from line 901, col 17.
        write('''</td>
        </tr>
    </table>
    ''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['properties']) # "$input($fields['properties'])" on line 904, col 5
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['properties'])")) # from line 904, col 5.
        write('''
''')
        _v = VFFSL(SL,"hiddenfields",False)(VFFSL(SL,"editbox.hiddenFields",True)) # '$hiddenfields($editbox.hiddenFields)' on line 905, col 1
        if _v is not None: write(_filter(_v, rawExpr='$hiddenfields($editbox.hiddenFields)')) # from line 905, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def serviceproperty(self, property, **KWS):



        ## CHEETAH: generated from #def serviceproperty($property) at line 909, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        args = VFFSL(SL,"property.args",True)
        optargs = VFFSL(SL,"property.optargs",True)
        if VFFSL(SL,"property.display",True): # generated from line 912, col 1
            style = ''
        else: # generated from line 914, col 1
            style = 'display:none;'
        write('''    <div id="''')
        _v = VFFSL(SL,"property.id",True) # '$property.id' on line 917, col 14
        if _v is not None: write(_filter(_v, rawExpr='$property.id')) # from line 917, col 14.
        write('''" style="''')
        _v = VFFSL(SL,"style",True) # '$style' on line 917, col 35
        if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 917, col 35.
        write('''">
        <p>''')
        _v = VFFSL(SL,"property.title",True) # '$property.title' on line 918, col 12
        if _v is not None: write(_filter(_v, rawExpr='$property.title')) # from line 918, col 12.
        write('''</p>
        <table class="header-active">
''')
        if len(VFFSL(SL,"property.args",True)): # generated from line 920, col 1
            write('''                <tr>
                    <th colspan="2">Required</th>
                </tr>
''')
            for field,content in VFN(VFFSL(SL,"args",True),"items",False)(): # generated from line 924, col 1
                write('''                <tr>
                    <td>''')
                _v = VFFSL(SL,"field",True) # '$field' on line 926, col 25
                if _v is not None: write(_filter(_v, rawExpr='$field')) # from line 926, col 25.
                write('''&nbsp;<span style="color: #ff0000">*</span></td>
                    <td>''')
                _v = VFFSL(SL,"input",False)(VFFSL(SL,"args",True)[VFFSL(SL,"field",True)]) # '$input($args[$field])' on line 927, col 25
                if _v is not None: write(_filter(_v, rawExpr='$input($args[$field])')) # from line 927, col 25.
                write('''</td>
                </tr>
''')
        if len(VFFSL(SL,"property.optargs",True)): # generated from line 931, col 1
            write('''                <tr>
                    <th colspan="2">Optional</th>
                </tr>
''')
            for field,content in VFN(VFFSL(SL,"optargs",True),"items",False)(): # generated from line 935, col 1
                write('''                <tr>
                    <td>''')
                _v = VFFSL(SL,"field",True) # '$field' on line 937, col 25
                if _v is not None: write(_filter(_v, rawExpr='$field')) # from line 937, col 25.
                write('''</td>
                    <td>''')
                _v = VFFSL(SL,"input",False)(VFFSL(SL,"optargs",True)[VFFSL(SL,"field",True)]) # '$input($optargs[$field])' on line 938, col 25
                if _v is not None: write(_filter(_v, rawExpr='$input($optargs[$field])')) # from line 938, col 25.
                write('''</td>
                </tr>
''')
        write('''        </table>
    </DIV>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def prefix(self, editbox, **KWS):



        ## CHEETAH: generated from #def prefix($editbox) at line 947, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['netaddr']) # "$heading($fields['netaddr'])" on line 951, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['netaddr'])")) # from line 951, col 29.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vlan.description']) # "$heading($fields['vlan.description'])" on line 952, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vlan.description'])")) # from line 952, col 17.
        write('''</th>
        </tr>
        <tr>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['netaddr']) # "$input($fields['netaddr'])" on line 955, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['netaddr'])")) # from line 955, col 29.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vlan.description'],style='width: 100%;') # "$input($fields['vlan.description'],style='width: 100%;')" on line 956, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vlan.description'],style='width: 100%;')")) # from line 956, col 17.
        write('''</td>
        </tr>
        <tr>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vlan.netident']) # "$heading($fields['vlan.netident'])" on line 959, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vlan.netident'])")) # from line 959, col 29.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vlan.orgid']) # "$heading($fields['vlan.orgid'])" on line 960, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vlan.orgid'])")) # from line 960, col 17.
        write('''</th>
        </tr>
        <tr>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vlan.netident']) # "$input($fields['vlan.netident'])" on line 963, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vlan.netident'])")) # from line 963, col 29.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vlan.orgid']) # "$input($fields['vlan.orgid'])" on line 964, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vlan.orgid'])")) # from line 964, col 17.
        write('''</td>
        </tr>
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vlan.nettype']) # "$heading($fields['vlan.nettype'])" on line 967, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vlan.nettype'])")) # from line 967, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vlan.vlan']) # "$heading($fields['vlan.vlan'])" on line 968, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vlan.vlan'])")) # from line 968, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vlan.usageid']) # "$heading($fields['vlan.usageid'])" on line 969, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vlan.usageid'])")) # from line 969, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vlan.nettype']) # "$input($fields['vlan.nettype'])" on line 972, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vlan.nettype'])")) # from line 972, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vlan.vlan']) # "$input($fields['vlan.vlan'])" on line 973, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vlan.vlan'])")) # from line 973, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vlan.usageid'],style='width: 100%') # "$input($fields['vlan.usageid'],style='width: 100%')" on line 974, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vlan.usageid'],style='width: 100%')")) # from line 974, col 17.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def vlan(self, editbox, **KWS):



        ## CHEETAH: generated from #def $vlan($editbox) at line 980, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['netident']) # "$heading($fields['netident'])" on line 984, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['netident'])")) # from line 984, col 29.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['orgid']) # "$heading($fields['orgid'])" on line 985, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['orgid'])")) # from line 985, col 17.
        write('''</th>
        </tr>
        <tr>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['netident']) # "$input($fields['netident'])" on line 988, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['netident'])")) # from line 988, col 29.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['orgid']) # "$input($fields['orgid'])" on line 989, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['orgid'])")) # from line 989, col 17.
        write('''</td>
        </tr>
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['nettype']) # "$heading($fields['nettype'])" on line 992, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['nettype'])")) # from line 992, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['vlan']) # "$heading($fields['vlan'])" on line 993, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['vlan'])")) # from line 993, col 17.
        write('''</th>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['usageid']) # "$heading($fields['usageid'])" on line 994, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['usageid'])")) # from line 994, col 17.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['nettype']) # "$input($fields['nettype'])" on line 997, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['nettype'])")) # from line 997, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['vlan']) # "$input($fields['vlan'])" on line 998, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['vlan'])")) # from line 998, col 17.
        write('''</td>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['usageid'],style='width: 100%') # "$input($fields['usageid'],style='width: 100%')" on line 999, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['usageid'],style='width: 100%')")) # from line 999, col 17.
        write('''</td>
        </tr>
        <tr>
            <th colspan="3">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['description']) # "$heading($fields['description'])" on line 1002, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['description'])")) # from line 1002, col 29.
        write('''</th>
        </tr>
        <tr>
            <td colspan="3">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['description'],style='width: 100%;') # "$input($fields['description'],style='width: 100%;')" on line 1005, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['description'],style='width: 100%;')")) # from line 1005, col 29.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def subcat(self, editbox, **KWS):



        ## CHEETAH: generated from #def subcat($editbox) at line 1011, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <table class="header-active">
        <tr>
            <th>''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['subcatid']) # "$heading($fields['subcatid'])" on line 1015, col 17
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['subcatid'])")) # from line 1015, col 17.
        write('''</th>
            <th colspan="2">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['catid']) # "$heading($fields['catid'])" on line 1016, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['catid'])")) # from line 1016, col 29.
        write('''</th>
        </tr>
        <tr>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['subcatid']) # "$input($fields['subcatid'])" on line 1019, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['subcatid'])")) # from line 1019, col 17.
        write('''</td>
            <td colspan="2">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['catid']) # "$input($fields['catid'])" on line 1020, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['catid'])")) # from line 1020, col 29.
        write('''</td>
        </tr>
        <tr>
            <th colspan="3">''')
        _v = VFFSL(SL,"heading",False)(VFFSL(SL,"fields",True)['descr']) # "$heading($fields['descr'])" on line 1023, col 29
        if _v is not None: write(_filter(_v, rawExpr="$heading($fields['descr'])")) # from line 1023, col 29.
        write('''</th>
        </tr>
        <tr>
            <td colspan="3">''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['descr'],'width: 100%;') # "$input($fields['descr'],'width: 100%;')" on line 1026, col 29
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['descr'],'width: 100%;')")) # from line 1026, col 29.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def hiddenormessage(self, editbox, **KWS):



        ## CHEETAH: generated from #def hiddenormessage($editbox) at line 1032, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<p>''')
        _v = VFFSL(SL,"editbox.message",True) # '$editbox.message' on line 1033, col 4
        if _v is not None: write(_filter(_v, rawExpr='$editbox.message')) # from line 1033, col 4.
        write('''</p>
<!-- def hiddenormessage -->
''')
        _v = VFFSL(SL,"hiddenfields",False)(VFFSL(SL,"editbox.hiddenFields",True)) # '$hiddenfields($editbox.hiddenFields)' on line 1035, col 1
        if _v is not None: write(_filter(_v, rawExpr='$hiddenfields($editbox.hiddenFields)')) # from line 1035, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def bulk(self, editbox, **KWS):



        ## CHEETAH: generated from #def bulk($editbox) at line 1039, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        fields = VFFSL(SL,"editbox.fields",True)
        write('''    <p>''')
        _v = VFFSL(SL,"editbox.help",True) # '$editbox.help' on line 1041, col 8
        if _v is not None: write(_filter(_v, rawExpr='$editbox.help')) # from line 1041, col 8.
        write('''</p>
    <table class="header-active">
        <tr>
            <th align="left">Import</th>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['table'],'width: 60%;') # "$input($fields['table'],'width: 60%;')" on line 1045, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['table'],'width: 60%;')")) # from line 1045, col 17.
        write('''</td>
        </tr>
        <tr>
            <th align="left">Separator</th>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['separator'],'width: 60%;') # "$input($fields['separator'],'width: 60%;')" on line 1049, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['separator'],'width: 60%;')")) # from line 1049, col 17.
        write('''</td>
        </tr>
        <tr>
            <th align="left">Import from file</th>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['file'],'width: 60%;') # "$input($fields['file'],'width: 60%;')" on line 1053, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['file'],'width: 60%;')")) # from line 1053, col 17.
        write('''</td>
        </tr>
        <tr>
            <th align="left">Import from text</th>
            <td>''')
        _v = VFFSL(SL,"input",False)(VFFSL(SL,"fields",True)['textarea']) # "$input($fields['textarea'])" on line 1057, col 17
        if _v is not None: write(_filter(_v, rawExpr="$input($fields['textarea'])")) # from line 1057, col 17.
        write('''</td>
        </tr>
    </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def hiddenfields(self, fieldlist, **KWS):



        ## CHEETAH: generated from #def hiddenfields($fieldlist) at line 1063, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        for field in VFN(VFFSL(SL,"fieldlist",True),"values",False)(): # generated from line 1064, col 1
            _v = VFFSL(SL,"input",False)(VFFSL(SL,"field",True)) # '$input($field)' on line 1065, col 1
            if _v is not None: write(_filter(_v, rawExpr='$input($field)')) # from line 1065, col 1.
            write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def heading(self, control, **KWS):



        ## CHEETAH: generated from #def heading($control) at line 1070, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  REQ_TRUE = 1 (from editdb.py header)
        if VFFSL(SL,"control",True)[1] == 1: # generated from line 1072, col 1
            _v = VFFSL(SL,"control",True)[2] # '$control[2]' on line 1073, col 1
            if _v is not None: write(_filter(_v, rawExpr='$control[2]')) # from line 1073, col 1.
            write('''&nbsp;<span style="color: #ff0000">*</span>
''')
        else: # generated from line 1074, col 1
            _v = VFFSL(SL,"control",True)[2] # '$control[2]' on line 1075, col 1
            if _v is not None: write(_filter(_v, rawExpr='$control[2]')) # from line 1075, col 1.
            write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def input(self, control, style='', **KWS):



        ## CHEETAH: generated from #def input($control,$style='') at line 1080, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        if VFN(VFFSL(SL,"control",True)[0],"disabled",True): # generated from line 1081, col 1
            disabled = 'disabled'
        else: # generated from line 1083, col 1
            disabled = ''
        control = VFFSL(SL,"control",True)[0]
        if VFFSL(SL,"control.type",True) == 'text': # generated from line 1087, col 1
            if VFFSL(SL,"control.maxlength",True): # generated from line 1088, col 1
                write('''<input ''')
                _v = VFFSL(SL,"disabled",True) # '$disabled' on line 1089, col 8
                if _v is not None: write(_filter(_v, rawExpr='$disabled')) # from line 1089, col 8.
                write(''' type="text" style="''')
                _v = VFFSL(SL,"style",True) # '$style' on line 1089, col 37
                if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1089, col 37.
                write('''" size="''')
                _v = VFFSL(SL,"control.size",True) # '$control.size' on line 1089, col 51
                if _v is not None: write(_filter(_v, rawExpr='$control.size')) # from line 1089, col 51.
                write('''" maxlength="''')
                _v = VFFSL(SL,"control.maxlength",True) # '$control.maxlength' on line 1089, col 77
                if _v is not None: write(_filter(_v, rawExpr='$control.maxlength')) # from line 1089, col 77.
                write('''" name="''')
                _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1089, col 103
                if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1089, col 103.
                write('''" value="''')
                _v = VFFSL(SL,"control.value",True) # '$control.value' on line 1089, col 125
                if _v is not None: write(_filter(_v, rawExpr='$control.value')) # from line 1089, col 125.
                write('''" />
''')
            else: # generated from line 1090, col 1
                write('''<input ''')
                _v = VFFSL(SL,"disabled",True) # '$disabled' on line 1091, col 8
                if _v is not None: write(_filter(_v, rawExpr='$disabled')) # from line 1091, col 8.
                write(''' type="text" style="''')
                _v = VFFSL(SL,"style",True) # '$style' on line 1091, col 37
                if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1091, col 37.
                write('''" size="''')
                _v = VFFSL(SL,"control.size",True) # '$control.size' on line 1091, col 51
                if _v is not None: write(_filter(_v, rawExpr='$control.size')) # from line 1091, col 51.
                write('''" name="''')
                _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1091, col 72
                if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1091, col 72.
                write('''" value="''')
                _v = VFFSL(SL,"control.value",True) # '$control.value' on line 1091, col 94
                if _v is not None: write(_filter(_v, rawExpr='$control.value')) # from line 1091, col 94.
                write('''" />
''')
        elif VFFSL(SL,"control.type",True) == 'select': # generated from line 1093, col 1
            write('''<select ''')
            _v = VFFSL(SL,"disabled",True) # '$disabled' on line 1094, col 9
            if _v is not None: write(_filter(_v, rawExpr='$disabled')) # from line 1094, col 9.
            write(''' name="''')
            _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1094, col 25
            if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1094, col 25.
            write('''" style="''')
            _v = VFFSL(SL,"style",True) # '$style' on line 1094, col 47
            if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1094, col 47.
            write('''" ''')
            _v = VFFSL(SL,"control.attribs",True) # '$control.attribs' on line 1094, col 55
            if _v is not None: write(_filter(_v, rawExpr='$control.attribs')) # from line 1094, col 55.
            write('''>
''')
            for id,option in VFFSL(SL,"control.options",True): # generated from line 1095, col 1
                if VFFSL(SL,"id",True) == VFFSL(SL,"control.value",True): # generated from line 1096, col 1
                    write('''    <option value="''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 1097, col 20
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 1097, col 20.
                    write('''" selected>''')
                    _v = VFFSL(SL,"option",True) # '$option' on line 1097, col 34
                    if _v is not None: write(_filter(_v, rawExpr='$option')) # from line 1097, col 34.
                    write('''</option>
''')
                else: # generated from line 1098, col 1
                    write('''    <option value="''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 1099, col 20
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 1099, col 20.
                    write('''">''')
                    _v = VFFSL(SL,"option",True) # '$option' on line 1099, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$option')) # from line 1099, col 25.
                    write('''</option>
''')
            write('''</select>
''')
        elif VFFSL(SL,"control.type",True) == 'multipleselect': # generated from line 1103, col 1
            write('''<select multiple name="''')
            _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1104, col 24
            if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1104, col 24.
            write('''" style="''')
            _v = VFFSL(SL,"style",True) # '$style' on line 1104, col 46
            if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1104, col 46.
            write('''">
''')
            for id,option in VFFSL(SL,"control.options",True): # generated from line 1105, col 1
                if VFN(VFFSL(SL,"control.value",True),"count",False)(VFFSL(SL,"id",True)): # generated from line 1106, col 1
                    write('''    <option value="''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 1107, col 20
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 1107, col 20.
                    write('''" selected>''')
                    _v = VFFSL(SL,"option",True) # '$option' on line 1107, col 34
                    if _v is not None: write(_filter(_v, rawExpr='$option')) # from line 1107, col 34.
                    write('''</option>
''')
                else: # generated from line 1108, col 1
                    write('''    <option value="''')
                    _v = VFFSL(SL,"id",True) # '$id' on line 1109, col 20
                    if _v is not None: write(_filter(_v, rawExpr='$id')) # from line 1109, col 20.
                    write('''">''')
                    _v = VFFSL(SL,"option",True) # '$option' on line 1109, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$option')) # from line 1109, col 25.
                    write('''</option>
''')
            write('''</select>
''')
        elif VFFSL(SL,"control.type",True) == 'file': # generated from line 1113, col 1
            write('''    <input type="file" style="''')
            _v = VFFSL(SL,"style",True) # '$style' on line 1114, col 31
            if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1114, col 31.
            write('''" name="''')
            _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1114, col 45
            if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1114, col 45.
            write('''" value="''')
            _v = VFFSL(SL,"control.value",True) # '$control.value' on line 1114, col 67
            if _v is not None: write(_filter(_v, rawExpr='$control.value')) # from line 1114, col 67.
            write('''" />
''')
        elif VFFSL(SL,"control.type",True) == 'textarea': # generated from line 1115, col 1
            write('''    <textarea name="''')
            _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1116, col 21
            if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1116, col 21.
            write('''" style="''')
            _v = VFFSL(SL,"style",True) # '$style' on line 1116, col 43
            if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1116, col 43.
            write('''" rows="''')
            _v = VFFSL(SL,"control.rows",True) # '$control.rows' on line 1116, col 57
            if _v is not None: write(_filter(_v, rawExpr='$control.rows')) # from line 1116, col 57.
            write('''" cols="''')
            _v = VFFSL(SL,"control.cols",True) # '$control.cols' on line 1116, col 78
            if _v is not None: write(_filter(_v, rawExpr='$control.cols')) # from line 1116, col 78.
            write('''">''')
            _v = VFFSL(SL,"control.value",True) # '$control.value' on line 1116, col 93
            if _v is not None: write(_filter(_v, rawExpr='$control.value')) # from line 1116, col 93.
            write('''</textarea>
''')
        elif VFFSL(SL,"control.type",True) == 'checkbox': # generated from line 1117, col 1
            if VFFSL(SL,"control.value",True) == '1': # generated from line 1118, col 1
                #  VALUE is hardcoded to 1, which is good for boolean fields in the db
                write('''    <input type="checkbox" style="''')
                _v = VFFSL(SL,"style",True) # '$style' on line 1120, col 35
                if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1120, col 35.
                write('''" name="''')
                _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1120, col 49
                if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1120, col 49.
                write('''" value="1" checked />
''')
            else: # generated from line 1121, col 1
                write('''    <input type="checkbox" style="''')
                _v = VFFSL(SL,"style",True) # '$style' on line 1122, col 35
                if _v is not None: write(_filter(_v, rawExpr='$style')) # from line 1122, col 35.
                write('''" name="''')
                _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1122, col 49
                if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1122, col 49.
                write('''" value="1" />
''')
        elif VFFSL(SL,"control.type",True) == 'hidden': # generated from line 1124, col 1
            write('''    <input type="hidden" name="''')
            _v = VFFSL(SL,"control.name",True) # '$control.name' on line 1125, col 32
            if _v is not None: write(_filter(_v, rawExpr='$control.name')) # from line 1125, col 32.
            write('''" value="''')
            _v = VFFSL(SL,"control.value",True) # '$control.value' on line 1125, col 54
            if _v is not None: write(_filter(_v, rawExpr='$control.value')) # from line 1125, col 54.
            write('''" />
''')
        elif VFFSL(SL,"control.type",True) == 'treeselect': # generated from line 1126, col 1
            ts = selectTreeTemplate()
            if VFFSL(SL,"control.treeselect",True): # generated from line 1128, col 1
                write('''    ''')
                _v = VFN(VFFSL(SL,"ts",True),"renderLayoutBox",False)(VFFSL(SL,"control.treeselect",True)) # '$ts.renderLayoutBox($control.treeselect)' on line 1129, col 5
                if _v is not None: write(_filter(_v, rawExpr='$ts.renderLayoutBox($control.treeselect)')) # from line 1129, col 5.
                write('''
''')
        elif VFFSL(SL,"control.type",True) == 'serviceproperties': # generated from line 1131, col 1
            for property in VFFSL(SL,"control.propertyList",True): # generated from line 1132, col 1
                write('''    ''')
                _v = VFFSL(SL,"serviceproperty",False)(VFFSL(SL,"property",True)) # '$serviceproperty($property)' on line 1133, col 5
                if _v is not None: write(_filter(_v, rawExpr='$serviceproperty($property)')) # from line 1133, col 5.
                write('''
''')
        else: # generated from line 1135, col 1
            write('''Undefined control
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  $Id: editdbTemplate.tmpl 3816 2007-01-22 16:02:50Z jodal $
        # 
        #  Copyright 2003, 2004 Norwegian University of Science and Technology
        # 
        #  This file is part of Network Administration Visualized (NAV)
        # 
        #  NAV is free software; you can redistribute it and/or modify
        #  it under the terms of the GNU General Public License as published by
        #  the Free Software Foundation; either version 2 of the License, or
        #  (at your option) any later version.
        # 
        #  NAV is distributed in the hope that it will be useful,
        #  but WITHOUT ANY WARRANTY; without even the implied warranty of
        #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        #  GNU General Public License for more details.
        # 
        #  You should have received a copy of the GNU General Public License
        #  along with NAV; if not, write to the Free Software
        #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
        # 
        # 
        #  Author: Hans Jrgen Hoel <hansjorg@orakel.ntnu.no>
        # 
        write('''


''')
        self.additionalJavaScript(trans=trans)
        write('''

''')
        #  function showSelectList
        # 
        #  Function for displaying a list in a table with optional
        #  radiobuttons or checkboxes for selecting rows
        # 
        #  $selectList
        #    ++-- title                     :: list title
        #    ++-- formMethod                :: method for form, post or get
        #    ++-- formAction                :: action for form
        #    ++-- selectCname               :: controlname for radiob./checkbox
        #    ++-- status                    :: editdb.status object
        #    ++-- buttonsTop                :: list of buttons for top of list
        #           +-- (cname,value)       :: tuple of control name and value (text)
        #    ++-- buttonsBottom             :: list of buttons for bottom of list
        #           +-- (cname,value)       :: tuple of control name and value (text)
        #    ++-- headings                  :: list of heading cells (cell objects)
        #           +-- text                :: heading text
        #           +-- url                 :: heading link (optional)
        #    ++-- rows                      :: array of rows
        #           +-- (id,cells)          :: tuple (id, list of cells)
        #                 +-- text          :: cell text
        #                 +-- url           :: link for this cell
        #                 +-- checkbox      :: boolean, show a checkbox in this cell
        #                 +-- radiobutton   :: boolean, show a radiobuttion
        #                 +-- image         :: path to an image (optional)
        #                 +-- tooltip       :: list of tooltip strings (optional) 
        # 
        write('''
''')
        #  function renderFilters
        # 
        #  Function for displaying list filters
        # 
        write('''

''')
        #  function showStatus
        # 
        #  Function for displaying status and error messages
        #  takes an editdb.status object as parameter
        # 
        #  $status
        #    +-- messages                   :: list of message strings
        #    +-- errors                     :: list of error strings
        # 
        write('''
''')
        #  Form to show a body object
        #  ie. display the editdb main menu
        write('''

''')
        #  Function to display a list for selecting
        #  which entries to edit, or delete
        write('''
''')
        #  This function displays the bar with add/edit/delete buttons
        write('''
''')
        #  Function for displaying a form for adding or editing
        write('''


''')
        # 
        #  Forms for adding and editing
        # 
        write('''
''')
        #  For for editing patches
        write('''
''')
        #  Form for editing cabling
        write('''
''')
        #  Form for entering a serialnumber
        write('''
''')
        #  Form for server subcat and function
        write('''
''')
        #  Form for adding or editing a netbox
        write('''
''')
        #  Form for adding or editing an snmpoid
        write('''



''')
        #  Form for adding or editing a room
        write('''
''')
        #  Form for adding or editing a location
        write('''
''')
        #  Form for adding or editing an org
        write('''
''')
        #  Form for adding or editing a type
        write('''
''')
        #  Form for adding or editing a product
        write('''
''')
        #  Form for adding or editing a container
        write('''
''')
        #  Form for adding or editing routers in containers
        write('''



''')
        #  Form for adding or editing a vendor
        write('''
''')
        #  Form for adding or editing a user category
        write('''
''')
        #  Form for adding or editing a service
        write('''
''')
        #  Form for editing serviceproperties (called by input())
        write('''
''')
        #  Form for prefix editing
        write('''
''')
        #  Form for vlan editing
        write('''
''')
        #  Form for adding or editing a subcategory
        write('''
''')
        #  Form for showing a message and adding hidden controls
        write('''
''')
        #  Form for bulk import
        write('''
''')
        #  Form to write out all hidden input fields
        write('''
''')
        #  Displays headings in forms, marks required fields
        write('''
''')
        #  Form to display all input fields
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_editdbTemplate= 'writeBody'

## END CLASS DEFINITION

if not hasattr(editdbTemplate, '_initCheetahAttributes'):
    templateAPIClass = getattr(editdbTemplate, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(editdbTemplate)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=editdbTemplate()).run()


