#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from UserAdmin import UserAdmin

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1222677394.9985051
__CHEETAH_genTimestamp__ = 'Mon Sep 29 08:36:34 2008'
__CHEETAH_src__ = 'useradmin/GroupList.tmpl'
__CHEETAH_srcLastModified__ = 'Mon Jul 17 06:35:04 2006'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class GroupList(UserAdmin):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        UserAdmin.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def add_group(self, group, **KWS):



        ## CHEETAH: generated from #def add_group($group) at line 29, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''    <tr class="''')
        _v = VFFSL(SL,"rowcycler",True) # '$rowcycler' on line 30, col 16
        if _v is not None: write(_filter(_v, rawExpr='$rowcycler')) # from line 30, col 16.
        write('''">
        <td><a href="/useradmin/group?id=''')
        _v = VFFSL(SL,"group.id",True) # '$group.id' on line 31, col 42
        if _v is not None: write(_filter(_v, rawExpr='$group.id')) # from line 31, col 42.
        write('''">''')
        _v = VFFSL(SL,"group.name",True) # '$group.name' on line 31, col 53
        if _v is not None: write(_filter(_v, rawExpr='$group.name')) # from line 31, col 53.
        write('''</a></td>
        <td>''')
        _v = VFFSL(SL,"group.description",True) # '$group.description' on line 32, col 13
        if _v is not None: write(_filter(_v, rawExpr='$group.description')) # from line 32, col 13.
        write('''</td>
        <td style="text-align: center;">''')
        _v = VFFSL(SL,"group.membercount",True) # '$group.membercount' on line 33, col 41
        if _v is not None: write(_filter(_v, rawExpr='$group.membercount')) # from line 33, col 41.
        write('''</td>
    </tr>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def useradmin(self, **KWS):



        ## CHEETAH: generated from #block useradmin at line 38, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
<table class="horiztable">

''')
        groupcount = len(VFFSL(SL,"groups",True))
        write('''    <caption>
        <span class="cornerkludge"></span>
        Group List<br />
        <span class="subtitle">''')
        _v = VFFSL(SL,"groupcount",True) # '$groupcount' on line 46, col 32
        if _v is not None: write(_filter(_v, rawExpr='$groupcount')) # from line 46, col 32.
        write(''' groups :
        <a href="group">Create new group</a></span>
    </caption>

''')
        rowcount = len(VFFSL(SL,"groups",True)) + 1
        write('''    <tr class="header">
        <td class="leftkludge" rowspan="''')
        _v = VFFSL(SL,"rowcount",True) # '$rowcount' on line 52, col 41
        if _v is not None: write(_filter(_v, rawExpr='$rowcount')) # from line 52, col 41.
        write('''"></td>
        <th>Name</th>
        <th>Description</th>
        <th style="text-align: center;"># of members</th>
        <td class="rightkludge" rowspan="''')
        _v = VFFSL(SL,"rowcount",True) # '$rowcount' on line 56, col 42
        if _v is not None: write(_filter(_v, rawExpr='$rowcount')) # from line 56, col 42.
        write('''"></td>
    </tr>

''')
        for group in VFFSL(SL,"groups",True): # generated from line 59, col 1
            write('''    ''')
            _v = VFFSL(SL,"add_group",False)(VFFSL(SL,"group",True)) # '$add_group($group)' on line 60, col 5
            if _v is not None: write(_filter(_v, rawExpr='$add_group($group)')) # from line 60, col 5.
            write('''
''')
        write('''</table>

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  $Id: GroupList.tmpl 3536 2006-07-17 06:35:04Z jodal $
        #  Extends the UserAdmin template for common useradmin structure.
        #  Builds html for the Group list screen of the useradmin module.
        # 
        #  Copyright 2003, 2004 Norwegian University of Science and Technology
        # 
        #  This file is part of Network Administration Visualized (NAV)
        # 
        #  NAV is free software; you can redistribute it and/or modify
        #  it under the terms of the GNU General Public License as published by
        #  the Free Software Foundation; either version 2 of the License, or
        #  (at your option) any later version.
        # 
        #  NAV is distributed in the hope that it will be useful,
        #  but WITHOUT ANY WARRANTY; without even the implied warranty of
        #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        #  GNU General Public License for more details.
        # 
        #  You should have received a copy of the GNU General Public License
        #  along with NAV; if not, write to the Free Software
        #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
        # 
        # 
        #  Authors: Morten Vold <morten.vold@itea.ntnu.no>
        # 
        write('''



''')
        self.useradmin(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_GroupList= 'writeBody'

## END CLASS DEFINITION

if not hasattr(GroupList, '_initCheetahAttributes'):
    templateAPIClass = getattr(GroupList, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(GroupList)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=GroupList()).run()


